/*
 * nheko Copyright (C) 2017  Konstantinos Sideris <siderisk@auth.gr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "emoji/Provider.h"

using namespace emoji;

const std::vector<Emoji> emoji::Provider::people = {
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x80"), "grinning face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x83"), "grinning face with big eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x84"), "grinning face with smiling eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x81"), "beaming face with smiling eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x86"), "grinning squinting face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x85"), "grinning face with sweat"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa3"), "rolling on the floor laughing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x82"), "face with tears of joy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x82"), "slightly smiling face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x83"), "upside-down face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x89"), "winking face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x8a"), "smiling face with smiling eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x87"), "smiling face with halo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb0"), "smiling face with hearts"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x8d"), "smiling face with heart-eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa9"), "star-struck"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x98"), "face blowing a kiss"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x97"), "kissing face"},
  Emoji{QString::fromUtf8("\xe2\x98\xba"), "smiling face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x9a"), "kissing face with closed eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x99"), "kissing face with smiling eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb2"), "smiling face with tear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x8b"), "face savoring food"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x9b"), "face with tongue"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x9c"), "winking face with tongue"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xaa"), "zany face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x9d"), "squinting face with tongue"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x91"), "money-mouth face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x97"), "hugging face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xad"), "face with hand over mouth"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xab"), "shushing face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x94"), "thinking face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x90"), "zipper-mouth face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa8"), "face with raised eyebrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x90"), "neutral face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x91"), "expressionless face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb6"), "face without mouth"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x8f"), "smirking face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x92"), "unamused face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x84"), "face with rolling eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xac"), "grimacing face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa5"), "lying face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x8c"), "relieved face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x94"), "pensive face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xaa"), "sleepy face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa4"), "drooling face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb4"), "sleeping face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb7"), "face with medical mask"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x92"), "face with thermometer"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x95"), "face with head-bandage"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa2"), "nauseated face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xae"), "face vomiting"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa7"), "sneezing face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb5"), "hot face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb6"), "cold face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb4"), "woozy face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb5"), "dizzy face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xaf"), "exploding head"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa0"), "cowboy hat face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb3"), "partying face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb8"), "disguised face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x8e"), "smiling face with sunglasses"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x93"), "nerd face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x90"), "face with monocle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x95"), "confused face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x9f"), "worried face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x81"), "slightly frowning face"},
  Emoji{QString::fromUtf8("\xe2\x98\xb9"), "frowning face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xae"), "face with open mouth"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xaf"), "hushed face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb2"), "astonished face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb3"), "flushed face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xba"), "pleading face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa6"), "frowning face with open mouth"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa7"), "anguished face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa8"), "fearful face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb0"), "anxious face with sweat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa5"), "sad but relieved face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa2"), "crying face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xad"), "loudly crying face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb1"), "face screaming in fear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x96"), "confounded face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa3"), "persevering face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x9e"), "disappointed face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x93"), "downcast face with sweat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa9"), "weary face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xab"), "tired face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb1"), "yawning face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa4"), "face with steam from nose"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa1"), "pouting face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xa0"), "angry face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xac"), "face with symbols on mouth"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\x88"), "smiling face with horns"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbf"), "angry face with horns"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x80"), "skull"},
  Emoji{QString::fromUtf8("\xe2\x98\xa0"), "skull and crossbones"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa9"), "pile of poo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa1"), "clown face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb9"), "ogre"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xba"), "goblin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbb"), "ghost"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbd"), "alien"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbe"), "alien monster"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x96"), "robot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xba"), "grinning cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb8"), "grinning cat with smiling eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xb9"), "cat with tears of joy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xbb"), "smiling cat with heart-eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xbc"), "cat with wry smile"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xbd"), "kissing cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x80"), "weary cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xbf"), "crying cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x98\xbe"), "pouting cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x88"), "see-no-evil monkey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x89"), "hear-no-evil monkey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8a"), "speak-no-evil monkey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x8b"), "kiss mark"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x8c"), "love letter"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x98"), "heart with arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x9d"), "heart with ribbon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x96"), "sparkling heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x97"), "growing heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x93"), "beating heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x9e"), "revolving hearts"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x95"), "two hearts"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x9f"), "heart decoration"},
  Emoji{QString::fromUtf8("\xe2\x9d\xa3"), "heart exclamation"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x94"), "broken heart"},
  Emoji{QString::fromUtf8("\xe2\x9d\xa4"), "red heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa1"), "orange heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x9b"), "yellow heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x9a"), "green heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x99"), "blue heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x9c"), "purple heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8e"), "brown heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\xa4"), "black heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8d"), "white heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaf"), "hundred points"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa2"), "anger symbol"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa5"), "collision"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xab"), "dizzy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa6"), "sweat droplets"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa8"), "dashing away"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb3"), "hole"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa3"), "bomb"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xac"), "speech balloon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x81\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f\x97\xa8"),
        "eye in speech bubble"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x81\xe2\x80\x8d\xf0\x9f\x97\xa8"), "eye in speech bubble"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xa8"), "left speech bubble"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xaf"), "right anger bubble"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xad"), "thought balloon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa4"), "zzz"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8b"), "waving hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8b\xf0\x9f\x8f\xbb"), "waving hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8b\xf0\x9f\x8f\xbc"),
        "waving hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8b\xf0\x9f\x8f\xbd"), "waving hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8b\xf0\x9f\x8f\xbe"),
        "waving hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8b\xf0\x9f\x8f\xbf"), "waving hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9a"), "raised back of hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9a\xf0\x9f\x8f\xbb"),
        "raised back of hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9a\xf0\x9f\x8f\xbc"),
        "raised back of hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9a\xf0\x9f\x8f\xbd"),
        "raised back of hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9a\xf0\x9f\x8f\xbe"),
        "raised back of hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9a\xf0\x9f\x8f\xbf"),
        "raised back of hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x90"), "hand with fingers splayed"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x90\xf0\x9f\x8f\xbb"),
        "hand with fingers splayed: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x90\xf0\x9f\x8f\xbc"),
        "hand with fingers splayed: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x90\xf0\x9f\x8f\xbd"),
        "hand with fingers splayed: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x90\xf0\x9f\x8f\xbe"),
        "hand with fingers splayed: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x90\xf0\x9f\x8f\xbf"),
        "hand with fingers splayed: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8b"), "raised hand"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8b\xf0\x9f\x8f\xbb"), "raised hand: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8b\xf0\x9f\x8f\xbc"), "raised hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8b\xf0\x9f\x8f\xbd"), "raised hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8b\xf0\x9f\x8f\xbe"), "raised hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8b\xf0\x9f\x8f\xbf"), "raised hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x96"), "vulcan salute"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x96\xf0\x9f\x8f\xbb"), "vulcan salute: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x96\xf0\x9f\x8f\xbc"),
        "vulcan salute: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x96\xf0\x9f\x8f\xbd"), "vulcan salute: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x96\xf0\x9f\x8f\xbe"),
        "vulcan salute: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x96\xf0\x9f\x8f\xbf"), "vulcan salute: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8c"), "OK hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8c\xf0\x9f\x8f\xbb"), "OK hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8c\xf0\x9f\x8f\xbc"), "OK hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8c\xf0\x9f\x8f\xbd"), "OK hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8c\xf0\x9f\x8f\xbe"), "OK hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8c\xf0\x9f\x8f\xbf"), "OK hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8c"), "pinched fingers"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8c\xf0\x9f\x8f\xbb"), "pinched fingers: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8c\xf0\x9f\x8f\xbc"),
        "pinched fingers: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8c\xf0\x9f\x8f\xbd"), "pinched fingers: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8c\xf0\x9f\x8f\xbe"),
        "pinched fingers: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8c\xf0\x9f\x8f\xbf"), "pinched fingers: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8f"), "pinching hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8f\xf0\x9f\x8f\xbb"), "pinching hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8f\xf0\x9f\x8f\xbc"),
        "pinching hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8f\xf0\x9f\x8f\xbd"), "pinching hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8f\xf0\x9f\x8f\xbe"),
        "pinching hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x8f\xf0\x9f\x8f\xbf"), "pinching hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8c"), "victory hand"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8c\xf0\x9f\x8f\xbb"), "victory hand: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8c\xf0\x9f\x8f\xbc"), "victory hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8c\xf0\x9f\x8f\xbd"), "victory hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8c\xf0\x9f\x8f\xbe"), "victory hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8c\xf0\x9f\x8f\xbf"), "victory hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9e"), "crossed fingers"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9e\xf0\x9f\x8f\xbb"), "crossed fingers: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9e\xf0\x9f\x8f\xbc"),
        "crossed fingers: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9e\xf0\x9f\x8f\xbd"), "crossed fingers: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9e\xf0\x9f\x8f\xbe"),
        "crossed fingers: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9e\xf0\x9f\x8f\xbf"), "crossed fingers: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9f"), "love-you gesture"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9f\xf0\x9f\x8f\xbb"), "love-you gesture: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9f\xf0\x9f\x8f\xbc"),
        "love-you gesture: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9f\xf0\x9f\x8f\xbd"),
        "love-you gesture: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9f\xf0\x9f\x8f\xbe"),
        "love-you gesture: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9f\xf0\x9f\x8f\xbf"), "love-you gesture: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x98"), "sign of the horns"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x98\xf0\x9f\x8f\xbb"),
        "sign of the horns: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x98\xf0\x9f\x8f\xbc"),
        "sign of the horns: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x98\xf0\x9f\x8f\xbd"),
        "sign of the horns: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x98\xf0\x9f\x8f\xbe"),
        "sign of the horns: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x98\xf0\x9f\x8f\xbf"), "sign of the horns: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x99"), "call me hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x99\xf0\x9f\x8f\xbb"), "call me hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x99\xf0\x9f\x8f\xbc"),
        "call me hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x99\xf0\x9f\x8f\xbd"), "call me hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x99\xf0\x9f\x8f\xbe"),
        "call me hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x99\xf0\x9f\x8f\xbf"), "call me hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x88"), "backhand index pointing left"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x88\xf0\x9f\x8f\xbb"),
        "backhand index pointing left: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x88\xf0\x9f\x8f\xbc"),
        "backhand index pointing left: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x88\xf0\x9f\x8f\xbd"),
        "backhand index pointing left: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x88\xf0\x9f\x8f\xbe"),
        "backhand index pointing left: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x88\xf0\x9f\x8f\xbf"),
        "backhand index pointing left: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x89"), "backhand index pointing right"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x89\xf0\x9f\x8f\xbb"),
        "backhand index pointing right: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x89\xf0\x9f\x8f\xbc"),
        "backhand index pointing right: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x89\xf0\x9f\x8f\xbd"),
        "backhand index pointing right: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x89\xf0\x9f\x8f\xbe"),
        "backhand index pointing right: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x89\xf0\x9f\x8f\xbf"),
        "backhand index pointing right: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x86"), "backhand index pointing up"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x86\xf0\x9f\x8f\xbb"),
        "backhand index pointing up: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x86\xf0\x9f\x8f\xbc"),
        "backhand index pointing up: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x86\xf0\x9f\x8f\xbd"),
        "backhand index pointing up: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x86\xf0\x9f\x8f\xbe"),
        "backhand index pointing up: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x86\xf0\x9f\x8f\xbf"),
        "backhand index pointing up: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x95"), "middle finger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x95\xf0\x9f\x8f\xbb"), "middle finger: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x95\xf0\x9f\x8f\xbc"),
        "middle finger: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x95\xf0\x9f\x8f\xbd"), "middle finger: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x95\xf0\x9f\x8f\xbe"),
        "middle finger: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x95\xf0\x9f\x8f\xbf"), "middle finger: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x87"), "backhand index pointing down"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x87\xf0\x9f\x8f\xbb"),
        "backhand index pointing down: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x87\xf0\x9f\x8f\xbc"),
        "backhand index pointing down: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x87\xf0\x9f\x8f\xbd"),
        "backhand index pointing down: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x87\xf0\x9f\x8f\xbe"),
        "backhand index pointing down: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x87\xf0\x9f\x8f\xbf"),
        "backhand index pointing down: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x98\x9d"), "index pointing up"},
  Emoji{QString::fromUtf8("\xe2\x98\x9d\xf0\x9f\x8f\xbb"), "index pointing up: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x98\x9d\xf0\x9f\x8f\xbc"),
        "index pointing up: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x98\x9d\xf0\x9f\x8f\xbd"), "index pointing up: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x98\x9d\xf0\x9f\x8f\xbe"),
        "index pointing up: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x98\x9d\xf0\x9f\x8f\xbf"), "index pointing up: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8d"), "thumbs up"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8d\xf0\x9f\x8f\xbb"), "thumbs up: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8d\xf0\x9f\x8f\xbc"), "thumbs up: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8d\xf0\x9f\x8f\xbd"), "thumbs up: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8d\xf0\x9f\x8f\xbe"), "thumbs up: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8d\xf0\x9f\x8f\xbf"), "thumbs up: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8e"), "thumbs down"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8e\xf0\x9f\x8f\xbb"), "thumbs down: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8e\xf0\x9f\x8f\xbc"),
        "thumbs down: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8e\xf0\x9f\x8f\xbd"), "thumbs down: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8e\xf0\x9f\x8f\xbe"),
        "thumbs down: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8e\xf0\x9f\x8f\xbf"), "thumbs down: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8a"), "raised fist"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8a\xf0\x9f\x8f\xbb"), "raised fist: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8a\xf0\x9f\x8f\xbc"), "raised fist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8a\xf0\x9f\x8f\xbd"), "raised fist: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8a\xf0\x9f\x8f\xbe"), "raised fist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8a\xf0\x9f\x8f\xbf"), "raised fist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8a"), "oncoming fist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8a\xf0\x9f\x8f\xbb"), "oncoming fist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8a\xf0\x9f\x8f\xbc"),
        "oncoming fist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8a\xf0\x9f\x8f\xbd"), "oncoming fist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8a\xf0\x9f\x8f\xbe"),
        "oncoming fist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8a\xf0\x9f\x8f\xbf"), "oncoming fist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9b"), "left-facing fist"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9b\xf0\x9f\x8f\xbb"), "left-facing fist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9b\xf0\x9f\x8f\xbc"),
        "left-facing fist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9b\xf0\x9f\x8f\xbd"),
        "left-facing fist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9b\xf0\x9f\x8f\xbe"),
        "left-facing fist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9b\xf0\x9f\x8f\xbf"), "left-facing fist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9c"), "right-facing fist"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9c\xf0\x9f\x8f\xbb"),
        "right-facing fist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9c\xf0\x9f\x8f\xbc"),
        "right-facing fist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9c\xf0\x9f\x8f\xbd"),
        "right-facing fist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9c\xf0\x9f\x8f\xbe"),
        "right-facing fist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9c\xf0\x9f\x8f\xbf"), "right-facing fist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8f"), "clapping hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8f\xf0\x9f\x8f\xbb"), "clapping hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8f\xf0\x9f\x8f\xbc"),
        "clapping hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8f\xf0\x9f\x8f\xbd"), "clapping hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8f\xf0\x9f\x8f\xbe"),
        "clapping hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x8f\xf0\x9f\x8f\xbf"), "clapping hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8c"), "raising hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8c\xf0\x9f\x8f\xbb"), "raising hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8c\xf0\x9f\x8f\xbc"),
        "raising hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8c\xf0\x9f\x8f\xbd"), "raising hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8c\xf0\x9f\x8f\xbe"),
        "raising hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8c\xf0\x9f\x8f\xbf"), "raising hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x90"), "open hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x90\xf0\x9f\x8f\xbb"), "open hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x90\xf0\x9f\x8f\xbc"),
        "open hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x90\xf0\x9f\x8f\xbd"), "open hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x90\xf0\x9f\x8f\xbe"), "open hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x90\xf0\x9f\x8f\xbf"), "open hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb2"), "palms up together"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb2\xf0\x9f\x8f\xbb"),
        "palms up together: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb2\xf0\x9f\x8f\xbc"),
        "palms up together: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb2\xf0\x9f\x8f\xbd"),
        "palms up together: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb2\xf0\x9f\x8f\xbe"),
        "palms up together: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb2\xf0\x9f\x8f\xbf"), "palms up together: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\x9d"), "handshake"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8f"), "folded hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8f\xf0\x9f\x8f\xbb"), "folded hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8f\xf0\x9f\x8f\xbc"),
        "folded hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8f\xf0\x9f\x8f\xbd"), "folded hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8f\xf0\x9f\x8f\xbe"),
        "folded hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8f\xf0\x9f\x8f\xbf"), "folded hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8d"), "writing hand"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8d\xf0\x9f\x8f\xbb"), "writing hand: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8d\xf0\x9f\x8f\xbc"), "writing hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8d\xf0\x9f\x8f\xbd"), "writing hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8d\xf0\x9f\x8f\xbe"), "writing hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8d\xf0\x9f\x8f\xbf"), "writing hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x85"), "nail polish"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x85\xf0\x9f\x8f\xbb"), "nail polish: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x85\xf0\x9f\x8f\xbc"),
        "nail polish: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x85\xf0\x9f\x8f\xbd"), "nail polish: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x85\xf0\x9f\x8f\xbe"),
        "nail polish: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x85\xf0\x9f\x8f\xbf"), "nail polish: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb3"), "selfie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb3\xf0\x9f\x8f\xbb"), "selfie: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb3\xf0\x9f\x8f\xbc"), "selfie: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb3\xf0\x9f\x8f\xbd"), "selfie: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb3\xf0\x9f\x8f\xbe"), "selfie: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb3\xf0\x9f\x8f\xbf"), "selfie: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaa"), "flexed biceps"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaa\xf0\x9f\x8f\xbb"), "flexed biceps: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaa\xf0\x9f\x8f\xbc"),
        "flexed biceps: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaa\xf0\x9f\x8f\xbd"), "flexed biceps: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaa\xf0\x9f\x8f\xbe"),
        "flexed biceps: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xaa\xf0\x9f\x8f\xbf"), "flexed biceps: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbe"), "mechanical arm"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbf"), "mechanical leg"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb5"), "leg"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb5\xf0\x9f\x8f\xbb"), "leg: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb5\xf0\x9f\x8f\xbc"), "leg: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb5\xf0\x9f\x8f\xbd"), "leg: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb5\xf0\x9f\x8f\xbe"), "leg: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb5\xf0\x9f\x8f\xbf"), "leg: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb6"), "foot"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb6\xf0\x9f\x8f\xbb"), "foot: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb6\xf0\x9f\x8f\xbc"), "foot: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb6\xf0\x9f\x8f\xbd"), "foot: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb6\xf0\x9f\x8f\xbe"), "foot: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb6\xf0\x9f\x8f\xbf"), "foot: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x82"), "ear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x82\xf0\x9f\x8f\xbb"), "ear: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x82\xf0\x9f\x8f\xbc"), "ear: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x82\xf0\x9f\x8f\xbd"), "ear: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x82\xf0\x9f\x8f\xbe"), "ear: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x82\xf0\x9f\x8f\xbf"), "ear: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbb"), "ear with hearing aid"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbb\xf0\x9f\x8f\xbb"),
        "ear with hearing aid: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbb\xf0\x9f\x8f\xbc"),
        "ear with hearing aid: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbb\xf0\x9f\x8f\xbd"),
        "ear with hearing aid: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbb\xf0\x9f\x8f\xbe"),
        "ear with hearing aid: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbb\xf0\x9f\x8f\xbf"),
        "ear with hearing aid: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x83"), "nose"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x83\xf0\x9f\x8f\xbb"), "nose: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x83\xf0\x9f\x8f\xbc"), "nose: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x83\xf0\x9f\x8f\xbd"), "nose: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x83\xf0\x9f\x8f\xbe"), "nose: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x83\xf0\x9f\x8f\xbf"), "nose: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa0"), "brain"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x80"), "anatomical heart"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x81"), "lungs"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb7"), "tooth"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb4"), "bone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x80"), "eyes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x81"), "eye"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x85"), "tongue"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x84"), "mouth"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb6"), "baby"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb6\xf0\x9f\x8f\xbb"), "baby: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb6\xf0\x9f\x8f\xbc"), "baby: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb6\xf0\x9f\x8f\xbd"), "baby: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb6\xf0\x9f\x8f\xbe"), "baby: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb6\xf0\x9f\x8f\xbf"), "baby: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x92"), "child"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x92\xf0\x9f\x8f\xbb"), "child: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x92\xf0\x9f\x8f\xbc"), "child: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x92\xf0\x9f\x8f\xbd"), "child: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x92\xf0\x9f\x8f\xbe"), "child: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x92\xf0\x9f\x8f\xbf"), "child: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa6"), "boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa6\xf0\x9f\x8f\xbb"), "boy: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa6\xf0\x9f\x8f\xbc"), "boy: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa6\xf0\x9f\x8f\xbd"), "boy: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa6\xf0\x9f\x8f\xbe"), "boy: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa6\xf0\x9f\x8f\xbf"), "boy: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa7"), "girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa7\xf0\x9f\x8f\xbb"), "girl: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa7\xf0\x9f\x8f\xbc"), "girl: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa7\xf0\x9f\x8f\xbd"), "girl: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa7\xf0\x9f\x8f\xbe"), "girl: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa7\xf0\x9f\x8f\xbf"), "girl: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91"), "person"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb"), "person: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc"), "person: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd"), "person: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe"), "person: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf"), "person: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1"), "person: blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbb"),
        "person: light skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbc"),
        "person: medium-light skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbd"),
        "person: medium skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbe"),
        "person: medium-dark skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbf"),
        "person: dark skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8"), "man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"), "man: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"), "man: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"), "man: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"), "man: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"), "man: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x94"), "man: beard"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x94\xf0\x9f\x8f\xbb"), "man: light skin tone, beard"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x94\xf0\x9f\x8f\xbc"),
        "man: medium-light skin tone, beard"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x94\xf0\x9f\x8f\xbd"), "man: medium skin tone, beard"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x94\xf0\x9f\x8f\xbe"), "man: medium-dark skin tone, beard"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x94\xf0\x9f\x8f\xbf"), "man: dark skin tone, beard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xb0"), "man: red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "man: light skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "man: medium-light skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "man: medium skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "man: medium-dark skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "man: dark skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xb1"), "man: curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "man: light skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "man: medium-light skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "man: medium skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "man: medium-dark skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "man: dark skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xb3"), "man: white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "man: light skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "man: medium-light skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "man: medium skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "man: medium-dark skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "man: dark skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xb2"), "man: bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "man: light skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "man: medium-light skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "man: medium skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "man: medium-dark skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "man: dark skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9"), "woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb"), "woman: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc"), "woman: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd"), "woman: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe"), "woman: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf"), "woman: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xb0"), "woman: red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "woman: light skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "woman: medium-light skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "woman: medium skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "woman: medium-dark skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "woman: dark skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xb0"), "person: red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "person: light skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "person: medium-light skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "person: medium skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "person: medium-dark skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb0"),
        "person: dark skin tone, red hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xb1"), "woman: curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "woman: light skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "woman: medium-light skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "woman: medium skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "woman: medium-dark skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "woman: dark skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xb1"), "person: curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "person: light skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "person: medium-light skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "person: medium skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "person: medium-dark skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb1"),
        "person: dark skin tone, curly hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xb3"), "woman: white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "woman: light skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "woman: medium-light skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "woman: medium skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "woman: medium-dark skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "woman: dark skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xb3"), "person: white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "person: light skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "person: medium-light skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "person: medium skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "person: medium-dark skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb3"),
        "person: dark skin tone, white hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xb2"), "woman: bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "woman: light skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "woman: medium-light skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "woman: medium skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "woman: medium-dark skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "woman: dark skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xb2"), "person: bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "person: light skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "person: medium-light skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "person: medium skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "person: medium-dark skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xb2"),
        "person: dark skin tone, bald"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xe2\x80\x8d\xe2\x99\x80"), "woman: blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman: light skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman: medium-light skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman: medium skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman: medium-dark skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman: dark skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xe2\x80\x8d\xe2\x99\x82"), "man: blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man: light skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man: medium-light skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man: medium skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man: medium-dark skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb1\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man: dark skin tone, blond hair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x93"), "older person"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x93\xf0\x9f\x8f\xbb"), "older person: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x93\xf0\x9f\x8f\xbc"),
        "older person: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x93\xf0\x9f\x8f\xbd"), "older person: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x93\xf0\x9f\x8f\xbe"),
        "older person: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x93\xf0\x9f\x8f\xbf"), "older person: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb4"), "old man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb4\xf0\x9f\x8f\xbb"), "old man: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb4\xf0\x9f\x8f\xbc"), "old man: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb4\xf0\x9f\x8f\xbd"), "old man: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb4\xf0\x9f\x8f\xbe"), "old man: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb4\xf0\x9f\x8f\xbf"), "old man: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb5"), "old woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb5\xf0\x9f\x8f\xbb"), "old woman: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb5\xf0\x9f\x8f\xbc"), "old woman: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb5\xf0\x9f\x8f\xbd"), "old woman: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb5\xf0\x9f\x8f\xbe"), "old woman: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb5\xf0\x9f\x8f\xbf"), "old woman: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d"), "person frowning"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbb"), "person frowning: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbc"),
        "person frowning: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbd"), "person frowning: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbe"),
        "person frowning: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbf"), "person frowning: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xe2\x80\x8d\xe2\x99\x82"), "man frowning"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man frowning: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man frowning: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man frowning: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man frowning: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man frowning: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xe2\x80\x8d\xe2\x99\x80"), "woman frowning"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman frowning: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman frowning: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman frowning: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman frowning: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8d\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman frowning: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e"), "person pouting"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbb"), "person pouting: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbc"),
        "person pouting: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbd"), "person pouting: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbe"),
        "person pouting: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbf"), "person pouting: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xe2\x80\x8d\xe2\x99\x82"), "man pouting"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man pouting: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man pouting: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man pouting: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man pouting: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man pouting: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xe2\x80\x8d\xe2\x99\x80"), "woman pouting"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman pouting: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman pouting: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman pouting: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman pouting: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8e\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman pouting: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85"), "person gesturing NO"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbb"),
        "person gesturing NO: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbc"),
        "person gesturing NO: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbd"),
        "person gesturing NO: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbe"),
        "person gesturing NO: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbf"),
        "person gesturing NO: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xe2\x80\x8d\xe2\x99\x82"), "man gesturing NO"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing NO: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing NO: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing NO: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing NO: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing NO: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xe2\x80\x8d\xe2\x99\x80"), "woman gesturing NO"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing NO: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing NO: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing NO: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing NO: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x85\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing NO: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86"), "person gesturing OK"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbb"),
        "person gesturing OK: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbc"),
        "person gesturing OK: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbd"),
        "person gesturing OK: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbe"),
        "person gesturing OK: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbf"),
        "person gesturing OK: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xe2\x80\x8d\xe2\x99\x82"), "man gesturing OK"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing OK: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing OK: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing OK: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing OK: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man gesturing OK: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xe2\x80\x8d\xe2\x99\x80"), "woman gesturing OK"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing OK: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing OK: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing OK: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing OK: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x86\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman gesturing OK: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81"), "person tipping hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbb"),
        "person tipping hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbc"),
        "person tipping hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbd"),
        "person tipping hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbe"),
        "person tipping hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbf"),
        "person tipping hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xe2\x80\x8d\xe2\x99\x82"), "man tipping hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man tipping hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man tipping hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man tipping hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man tipping hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man tipping hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xe2\x80\x8d\xe2\x99\x80"), "woman tipping hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman tipping hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman tipping hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman tipping hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman tipping hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x81\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman tipping hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b"), "person raising hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbb"),
        "person raising hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbc"),
        "person raising hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbd"),
        "person raising hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbe"),
        "person raising hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbf"),
        "person raising hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xe2\x80\x8d\xe2\x99\x82"), "man raising hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man raising hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man raising hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man raising hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man raising hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man raising hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xe2\x80\x8d\xe2\x99\x80"), "woman raising hand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman raising hand: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman raising hand: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman raising hand: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman raising hand: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x8b\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman raising hand: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f"), "deaf person"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbb"), "deaf person: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbc"),
        "deaf person: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbd"), "deaf person: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbe"),
        "deaf person: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbf"), "deaf person: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xe2\x80\x8d\xe2\x99\x82"), "deaf man"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "deaf man: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "deaf man: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "deaf man: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "deaf man: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "deaf man: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xe2\x80\x8d\xe2\x99\x80"), "deaf woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "deaf woman: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "deaf woman: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "deaf woman: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "deaf woman: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8f\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "deaf woman: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87"), "person bowing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbb"), "person bowing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbc"),
        "person bowing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbd"), "person bowing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbe"),
        "person bowing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbf"), "person bowing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xe2\x80\x8d\xe2\x99\x82"), "man bowing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man bowing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man bowing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man bowing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man bowing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man bowing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xe2\x80\x8d\xe2\x99\x80"), "woman bowing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman bowing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman bowing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman bowing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman bowing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x99\x87\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman bowing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6"), "person facepalming"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbb"),
        "person facepalming: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbc"),
        "person facepalming: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbd"),
        "person facepalming: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbe"),
        "person facepalming: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbf"),
        "person facepalming: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xe2\x80\x8d\xe2\x99\x82"), "man facepalming"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man facepalming: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man facepalming: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man facepalming: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man facepalming: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man facepalming: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xe2\x80\x8d\xe2\x99\x80"), "woman facepalming"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman facepalming: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman facepalming: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman facepalming: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman facepalming: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xa6\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman facepalming: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7"), "person shrugging"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbb"), "person shrugging: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbc"),
        "person shrugging: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbd"),
        "person shrugging: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbe"),
        "person shrugging: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbf"), "person shrugging: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xe2\x80\x8d\xe2\x99\x82"), "man shrugging"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man shrugging: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man shrugging: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man shrugging: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man shrugging: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man shrugging: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xe2\x80\x8d\xe2\x99\x80"), "woman shrugging"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman shrugging: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman shrugging: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman shrugging: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman shrugging: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb7\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman shrugging: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xe2\x9a\x95"), "health worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9a\x95"),
        "health worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9a\x95"),
        "health worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9a\x95"),
        "health worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9a\x95"),
        "health worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9a\x95"),
        "health worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9a\x95"), "man health worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9a\x95"),
        "man health worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9a\x95"),
        "man health worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9a\x95"),
        "man health worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9a\x95"),
        "man health worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9a\x95"),
        "man health worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9a\x95"), "woman health worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9a\x95"),
        "woman health worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9a\x95"),
        "woman health worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9a\x95"),
        "woman health worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9a\x95"),
        "woman health worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9a\x95"),
        "woman health worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8e\x93"), "student"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "student: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "student: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "student: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "student: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "student: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8e\x93"), "man student"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "man student: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "man student: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "man student: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "man student: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "man student: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8e\x93"), "woman student"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "woman student: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "woman student: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "woman student: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "woman student: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\x93"),
        "woman student: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8f\xab"), "teacher"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "teacher: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "teacher: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "teacher: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "teacher: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "teacher: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8f\xab"), "man teacher"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "man teacher: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "man teacher: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "man teacher: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "man teacher: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "man teacher: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8f\xab"), "woman teacher"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "woman teacher: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "woman teacher: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "woman teacher: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "woman teacher: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8f\xab"),
        "woman teacher: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xe2\x9a\x96"), "judge"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9a\x96"),
        "judge: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9a\x96"),
        "judge: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9a\x96"),
        "judge: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9a\x96"),
        "judge: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9a\x96"),
        "judge: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9a\x96"), "man judge"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9a\x96"),
        "man judge: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9a\x96"),
        "man judge: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9a\x96"),
        "man judge: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9a\x96"),
        "man judge: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9a\x96"),
        "man judge: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9a\x96"), "woman judge"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9a\x96"),
        "woman judge: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9a\x96"),
        "woman judge: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9a\x96"),
        "woman judge: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9a\x96"),
        "woman judge: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9a\x96"),
        "woman judge: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8c\xbe"), "farmer"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "farmer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "farmer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "farmer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "farmer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "farmer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8c\xbe"), "man farmer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "man farmer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "man farmer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "man farmer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "man farmer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "man farmer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8c\xbe"), "woman farmer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "woman farmer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "woman farmer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "woman farmer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "woman farmer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8c\xbe"),
        "woman farmer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8d\xb3"), "cook"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "cook: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "cook: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "cook: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "cook: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "cook: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8d\xb3"), "man cook"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "man cook: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "man cook: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "man cook: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "man cook: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "man cook: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8d\xb3"), "woman cook"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "woman cook: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "woman cook: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "woman cook: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "woman cook: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8d\xb3"),
        "woman cook: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x94\xa7"), "mechanic"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "mechanic: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "mechanic: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "mechanic: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "mechanic: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "mechanic: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x94\xa7"), "man mechanic"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "man mechanic: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "man mechanic: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "man mechanic: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "man mechanic: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "man mechanic: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x94\xa7"), "woman mechanic"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "woman mechanic: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "woman mechanic: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "woman mechanic: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "woman mechanic: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x94\xa7"),
        "woman mechanic: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8f\xad"), "factory worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "factory worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "factory worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "factory worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "factory worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "factory worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8f\xad"), "man factory worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "man factory worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "man factory worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "man factory worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "man factory worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "man factory worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8f\xad"), "woman factory worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "woman factory worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "woman factory worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "woman factory worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "woman factory worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8f\xad"),
        "woman factory worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x92\xbc"), "office worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "office worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "office worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "office worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "office worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "office worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x92\xbc"), "man office worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "man office worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "man office worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "man office worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "man office worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "man office worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x92\xbc"), "woman office worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "woman office worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "woman office worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "woman office worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "woman office worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x92\xbc"),
        "woman office worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x94\xac"), "scientist"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "scientist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "scientist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "scientist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "scientist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "scientist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x94\xac"), "man scientist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "man scientist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "man scientist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "man scientist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "man scientist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "man scientist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x94\xac"), "woman scientist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "woman scientist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "woman scientist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "woman scientist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "woman scientist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x94\xac"),
        "woman scientist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x92\xbb"), "technologist"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "technologist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "technologist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "technologist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "technologist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "technologist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x92\xbb"), "man technologist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "man technologist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "man technologist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "man technologist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "man technologist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "man technologist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x92\xbb"), "woman technologist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "woman technologist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "woman technologist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "woman technologist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "woman technologist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x92\xbb"),
        "woman technologist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8e\xa4"), "singer"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "singer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "singer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "singer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "singer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "singer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8e\xa4"), "man singer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "man singer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "man singer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "man singer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "man singer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "man singer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8e\xa4"), "woman singer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "woman singer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "woman singer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "woman singer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "woman singer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\xa4"),
        "woman singer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8e\xa8"), "artist"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "artist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "artist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "artist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "artist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "artist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8e\xa8"), "man artist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "man artist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "man artist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "man artist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "man artist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "man artist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8e\xa8"), "woman artist"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "woman artist: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "woman artist: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "woman artist: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "woman artist: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\xa8"),
        "woman artist: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xe2\x9c\x88"), "pilot"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9c\x88"),
        "pilot: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9c\x88"),
        "pilot: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9c\x88"),
        "pilot: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9c\x88"),
        "pilot: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9c\x88"),
        "pilot: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9c\x88"), "man pilot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9c\x88"),
        "man pilot: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9c\x88"),
        "man pilot: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9c\x88"),
        "man pilot: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9c\x88"),
        "man pilot: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9c\x88"),
        "man pilot: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9c\x88"), "woman pilot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x9c\x88"),
        "woman pilot: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x9c\x88"),
        "woman pilot: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x9c\x88"),
        "woman pilot: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x9c\x88"),
        "woman pilot: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x9c\x88"),
        "woman pilot: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x9a\x80"), "astronaut"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "astronaut: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "astronaut: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "astronaut: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "astronaut: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "astronaut: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x9a\x80"), "man astronaut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "man astronaut: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "man astronaut: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "man astronaut: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "man astronaut: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "man astronaut: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x9a\x80"), "woman astronaut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "woman astronaut: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "woman astronaut: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "woman astronaut: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "woman astronaut: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x9a\x80"),
        "woman astronaut: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x9a\x92"), "firefighter"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "firefighter: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "firefighter: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "firefighter: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "firefighter: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "firefighter: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x9a\x92"), "man firefighter"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "man firefighter: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "man firefighter: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "man firefighter: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "man firefighter: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "man firefighter: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x9a\x92"), "woman firefighter"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "woman firefighter: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "woman firefighter: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "woman firefighter: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "woman firefighter: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x9a\x92"),
        "woman firefighter: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae"), "police officer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbb"), "police officer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbc"),
        "police officer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbd"), "police officer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbe"),
        "police officer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbf"), "police officer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xe2\x80\x8d\xe2\x99\x82"), "man police officer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man police officer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man police officer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man police officer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man police officer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man police officer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xe2\x80\x8d\xe2\x99\x80"), "woman police officer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman police officer: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman police officer: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman police officer: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman police officer: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xae\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman police officer: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5"), "detective"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbb"), "detective: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbc"), "detective: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbd"), "detective: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbe"), "detective: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbf"), "detective: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x82"), "man detective"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xe2\x80\x8d\xe2\x99\x82"), "man detective"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man detective: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man detective: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man detective: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man detective: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man detective: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x80"),
        "woman detective"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xe2\x80\x8d\xe2\x99\x80"), "woman detective"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman detective: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman detective: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman detective: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman detective: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb5\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman detective: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82"), "guard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbb"), "guard: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbc"), "guard: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbd"), "guard: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbe"), "guard: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbf"), "guard: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xe2\x80\x8d\xe2\x99\x82"), "man guard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man guard: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man guard: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man guard: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man guard: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man guard: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xe2\x80\x8d\xe2\x99\x80"), "woman guard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman guard: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman guard: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman guard: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman guard: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x82\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman guard: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7"), "construction worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbb"),
        "construction worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbc"),
        "construction worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbd"),
        "construction worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbe"),
        "construction worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbf"),
        "construction worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xe2\x80\x8d\xe2\x99\x82"), "man construction worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man construction worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man construction worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man construction worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man construction worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man construction worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xe2\x80\x8d\xe2\x99\x80"), "woman construction worker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman construction worker: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman construction worker: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman construction worker: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman construction worker: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb7\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman construction worker: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb4"), "prince"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb4\xf0\x9f\x8f\xbb"), "prince: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb4\xf0\x9f\x8f\xbc"), "prince: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb4\xf0\x9f\x8f\xbd"), "prince: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb4\xf0\x9f\x8f\xbe"), "prince: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb4\xf0\x9f\x8f\xbf"), "prince: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb8"), "princess"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb8\xf0\x9f\x8f\xbb"), "princess: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb8\xf0\x9f\x8f\xbc"), "princess: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb8\xf0\x9f\x8f\xbd"), "princess: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb8\xf0\x9f\x8f\xbe"), "princess: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb8\xf0\x9f\x8f\xbf"), "princess: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3"), "person wearing turban"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbb"),
        "person wearing turban: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbc"),
        "person wearing turban: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbd"),
        "person wearing turban: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbe"),
        "person wearing turban: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbf"),
        "person wearing turban: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xe2\x80\x8d\xe2\x99\x82"), "man wearing turban"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man wearing turban: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man wearing turban: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man wearing turban: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man wearing turban: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man wearing turban: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xe2\x80\x8d\xe2\x99\x80"), "woman wearing turban"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman wearing turban: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman wearing turban: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman wearing turban: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman wearing turban: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb3\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman wearing turban: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb2"), "man with skullcap"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb2\xf0\x9f\x8f\xbb"),
        "man with skullcap: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb2\xf0\x9f\x8f\xbc"),
        "man with skullcap: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb2\xf0\x9f\x8f\xbd"),
        "man with skullcap: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb2\xf0\x9f\x8f\xbe"),
        "man with skullcap: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb2\xf0\x9f\x8f\xbf"), "man with skullcap: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x95"), "woman with headscarf"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x95\xf0\x9f\x8f\xbb"),
        "woman with headscarf: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x95\xf0\x9f\x8f\xbc"),
        "woman with headscarf: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x95\xf0\x9f\x8f\xbd"),
        "woman with headscarf: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x95\xf0\x9f\x8f\xbe"),
        "woman with headscarf: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x95\xf0\x9f\x8f\xbf"),
        "woman with headscarf: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5"), "man in tuxedo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbb"), "man in tuxedo: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbc"),
        "man in tuxedo: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbd"), "man in tuxedo: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbe"),
        "man in tuxedo: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbf"), "man in tuxedo: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xe2\x80\x8d\xe2\x99\x82"), "man in tuxedo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man in tuxedo: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man in tuxedo: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man in tuxedo: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man in tuxedo: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man in tuxedo: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xe2\x80\x8d\xe2\x99\x80"), "woman in tuxedo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman in tuxedo: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman in tuxedo: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman in tuxedo: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman in tuxedo: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb5\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman in tuxedo: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0"), "bride with veil"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbb"), "bride with veil: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbc"),
        "bride with veil: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbd"), "bride with veil: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbe"),
        "bride with veil: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbf"), "bride with veil: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xe2\x80\x8d\xe2\x99\x82"), "man with veil"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man with veil: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man with veil: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man with veil: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man with veil: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man with veil: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xe2\x80\x8d\xe2\x99\x80"), "woman with veil"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman with veil: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman with veil: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman with veil: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman with veil: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xb0\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman with veil: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb0"), "pregnant woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb0\xf0\x9f\x8f\xbb"), "pregnant woman: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb0\xf0\x9f\x8f\xbc"),
        "pregnant woman: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb0\xf0\x9f\x8f\xbd"), "pregnant woman: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb0\xf0\x9f\x8f\xbe"),
        "pregnant woman: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb0\xf0\x9f\x8f\xbf"), "pregnant woman: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb1"), "breast-feeding"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb1\xf0\x9f\x8f\xbb"), "breast-feeding: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb1\xf0\x9f\x8f\xbc"),
        "breast-feeding: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb1\xf0\x9f\x8f\xbd"), "breast-feeding: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb1\xf0\x9f\x8f\xbe"),
        "breast-feeding: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb1\xf0\x9f\x8f\xbf"), "breast-feeding: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x8d\xbc"), "woman feeding baby"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "woman feeding baby: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "woman feeding baby: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "woman feeding baby: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "woman feeding baby: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "woman feeding baby: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x8d\xbc"), "man feeding baby"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "man feeding baby: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "man feeding baby: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "man feeding baby: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "man feeding baby: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "man feeding baby: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8d\xbc"), "person feeding baby"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "person feeding baby: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "person feeding baby: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "person feeding baby: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "person feeding baby: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8d\xbc"),
        "person feeding baby: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbc"), "baby angel"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbc\xf0\x9f\x8f\xbb"), "baby angel: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbc\xf0\x9f\x8f\xbc"),
        "baby angel: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbc\xf0\x9f\x8f\xbd"), "baby angel: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbc\xf0\x9f\x8f\xbe"), "baby angel: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xbc\xf0\x9f\x8f\xbf"), "baby angel: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x85"), "Santa Claus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x85\xf0\x9f\x8f\xbb"), "Santa Claus: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x85\xf0\x9f\x8f\xbc"),
        "Santa Claus: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x85\xf0\x9f\x8f\xbd"), "Santa Claus: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x85\xf0\x9f\x8f\xbe"),
        "Santa Claus: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x85\xf0\x9f\x8f\xbf"), "Santa Claus: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb6"), "Mrs. Claus"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb6\xf0\x9f\x8f\xbb"), "Mrs. Claus: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb6\xf0\x9f\x8f\xbc"),
        "Mrs. Claus: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb6\xf0\x9f\x8f\xbd"), "Mrs. Claus: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb6\xf0\x9f\x8f\xbe"), "Mrs. Claus: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb6\xf0\x9f\x8f\xbf"), "Mrs. Claus: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\x8e\x84"), "mx claus"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\x8e\x84"),
        "mx claus: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\x8e\x84"),
        "mx claus: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\x8e\x84"),
        "mx claus: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\x8e\x84"),
        "mx claus: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\x8e\x84"),
        "mx claus: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8"), "superhero"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbb"), "superhero: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbc"), "superhero: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbd"), "superhero: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbe"), "superhero: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbf"), "superhero: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xe2\x80\x8d\xe2\x99\x82"), "man superhero"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man superhero: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man superhero: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man superhero: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man superhero: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man superhero: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xe2\x80\x8d\xe2\x99\x80"), "woman superhero"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman superhero: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman superhero: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman superhero: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman superhero: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman superhero: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9"), "supervillain"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbb"), "supervillain: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbc"),
        "supervillain: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbd"), "supervillain: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbe"),
        "supervillain: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbf"), "supervillain: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xe2\x80\x8d\xe2\x99\x82"), "man supervillain"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man supervillain: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man supervillain: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man supervillain: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man supervillain: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man supervillain: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xe2\x80\x8d\xe2\x99\x80"), "woman supervillain"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman supervillain: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman supervillain: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman supervillain: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman supervillain: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xb9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman supervillain: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99"), "mage"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbb"), "mage: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbc"), "mage: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbd"), "mage: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbe"), "mage: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbf"), "mage: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xe2\x80\x8d\xe2\x99\x82"), "man mage"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man mage: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man mage: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man mage: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man mage: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man mage: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xe2\x80\x8d\xe2\x99\x80"), "woman mage"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman mage: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman mage: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman mage: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman mage: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x99\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman mage: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a"), "fairy"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbb"), "fairy: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbc"), "fairy: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbd"), "fairy: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbe"), "fairy: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbf"), "fairy: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xe2\x80\x8d\xe2\x99\x82"), "man fairy"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man fairy: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man fairy: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man fairy: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man fairy: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man fairy: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xe2\x80\x8d\xe2\x99\x80"), "woman fairy"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman fairy: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman fairy: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman fairy: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman fairy: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9a\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman fairy: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b"), "vampire"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbb"), "vampire: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbc"), "vampire: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbd"), "vampire: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbe"), "vampire: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbf"), "vampire: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xe2\x80\x8d\xe2\x99\x82"), "man vampire"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man vampire: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man vampire: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man vampire: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man vampire: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man vampire: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xe2\x80\x8d\xe2\x99\x80"), "woman vampire"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman vampire: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman vampire: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman vampire: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman vampire: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9b\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman vampire: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c"), "merperson"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbb"), "merperson: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbc"), "merperson: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbd"), "merperson: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbe"), "merperson: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbf"), "merperson: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xe2\x80\x8d\xe2\x99\x82"), "merman"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "merman: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "merman: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "merman: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "merman: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "merman: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xe2\x80\x8d\xe2\x99\x80"), "mermaid"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "mermaid: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "mermaid: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "mermaid: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "mermaid: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9c\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "mermaid: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d"), "elf"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbb"), "elf: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbc"), "elf: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbd"), "elf: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbe"), "elf: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbf"), "elf: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xe2\x80\x8d\xe2\x99\x82"), "man elf"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man elf: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man elf: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man elf: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man elf: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man elf: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xe2\x80\x8d\xe2\x99\x80"), "woman elf"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman elf: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman elf: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman elf: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman elf: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9d\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman elf: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9e"), "genie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9e\xe2\x80\x8d\xe2\x99\x82"), "man genie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9e\xe2\x80\x8d\xe2\x99\x80"), "woman genie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9f"), "zombie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9f\xe2\x80\x8d\xe2\x99\x82"), "man zombie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x9f\xe2\x80\x8d\xe2\x99\x80"), "woman zombie"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86"), "person getting massage"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbb"),
        "person getting massage: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbc"),
        "person getting massage: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbd"),
        "person getting massage: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbe"),
        "person getting massage: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbf"),
        "person getting massage: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xe2\x80\x8d\xe2\x99\x82"), "man getting massage"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man getting massage: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man getting massage: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man getting massage: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man getting massage: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man getting massage: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xe2\x80\x8d\xe2\x99\x80"), "woman getting massage"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting massage: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting massage: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting massage: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting massage: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x86\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting massage: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87"), "person getting haircut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbb"),
        "person getting haircut: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbc"),
        "person getting haircut: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbd"),
        "person getting haircut: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbe"),
        "person getting haircut: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbf"),
        "person getting haircut: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xe2\x80\x8d\xe2\x99\x82"), "man getting haircut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man getting haircut: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man getting haircut: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man getting haircut: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man getting haircut: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man getting haircut: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xe2\x80\x8d\xe2\x99\x80"), "woman getting haircut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting haircut: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting haircut: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting haircut: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting haircut: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x87\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman getting haircut: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6"), "person walking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbb"), "person walking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbc"),
        "person walking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbd"), "person walking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbe"),
        "person walking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbf"), "person walking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xe2\x80\x8d\xe2\x99\x82"), "man walking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man walking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man walking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man walking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man walking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man walking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xe2\x80\x8d\xe2\x99\x80"), "woman walking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman walking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman walking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman walking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman walking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb6\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman walking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d"), "person standing"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbb"), "person standing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbc"),
        "person standing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbd"), "person standing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbe"),
        "person standing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbf"), "person standing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xe2\x80\x8d\xe2\x99\x82"), "man standing"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man standing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man standing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man standing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man standing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man standing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xe2\x80\x8d\xe2\x99\x80"), "woman standing"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman standing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman standing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman standing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman standing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8d\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman standing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e"), "person kneeling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbb"), "person kneeling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbc"),
        "person kneeling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbd"), "person kneeling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbe"),
        "person kneeling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbf"), "person kneeling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xe2\x80\x8d\xe2\x99\x82"), "man kneeling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man kneeling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man kneeling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man kneeling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man kneeling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man kneeling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xe2\x80\x8d\xe2\x99\x80"), "woman kneeling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman kneeling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman kneeling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman kneeling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman kneeling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8e\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman kneeling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "person with probing cane"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "person with probing cane: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "person with probing cane: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "person with probing cane: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "person with probing cane: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "person with probing cane: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xaf"), "man with probing cane"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "man with probing cane: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "man with probing cane: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "man with probing cane: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "man with probing cane: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "man with probing cane: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "woman with probing cane"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "woman with probing cane: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "woman with probing cane: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "woman with probing cane: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "woman with probing cane: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xaf"),
        "woman with probing cane: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "person in motorized wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "person in motorized wheelchair: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "person in motorized wheelchair: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "person in motorized wheelchair: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "person in motorized wheelchair: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "person in motorized wheelchair: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "man in motorized wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "man in motorized wheelchair: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "man in motorized wheelchair: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "man in motorized wheelchair: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "man in motorized wheelchair: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "man in motorized wheelchair: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "woman in motorized wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "woman in motorized wheelchair: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "woman in motorized wheelchair: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "woman in motorized wheelchair: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "woman in motorized wheelchair: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xbc"),
        "woman in motorized wheelchair: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "person in manual wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "person in manual wheelchair: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "person in manual wheelchair: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "person in manual wheelchair: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "person in manual wheelchair: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "person in manual wheelchair: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "man in manual wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "man in manual wheelchair: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "man in manual wheelchair: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "man in manual wheelchair: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "man in manual wheelchair: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "man in manual wheelchair: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "woman in manual wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "woman in manual wheelchair: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "woman in manual wheelchair: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "woman in manual wheelchair: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "woman in manual wheelchair: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa6\xbd"),
        "woman in manual wheelchair: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83"), "person running"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbb"), "person running: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbc"),
        "person running: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbd"), "person running: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbe"),
        "person running: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbf"), "person running: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xe2\x80\x8d\xe2\x99\x82"), "man running"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man running: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man running: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man running: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man running: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man running: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xe2\x80\x8d\xe2\x99\x80"), "woman running"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman running: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman running: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman running: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman running: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x83\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman running: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x83"), "woman dancing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x83\xf0\x9f\x8f\xbb"), "woman dancing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x83\xf0\x9f\x8f\xbc"),
        "woman dancing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x83\xf0\x9f\x8f\xbd"), "woman dancing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x83\xf0\x9f\x8f\xbe"),
        "woman dancing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x83\xf0\x9f\x8f\xbf"), "woman dancing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xba"), "man dancing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xba\xf0\x9f\x8f\xbb"), "man dancing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xba\xf0\x9f\x8f\xbc"),
        "man dancing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xba\xf0\x9f\x8f\xbd"), "man dancing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xba\xf0\x9f\x8f\xbe"),
        "man dancing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xba\xf0\x9f\x8f\xbf"), "man dancing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb4"), "man in suit levitating"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb4\xf0\x9f\x8f\xbb"),
        "man in suit levitating: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb4\xf0\x9f\x8f\xbc"),
        "man in suit levitating: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb4\xf0\x9f\x8f\xbd"),
        "man in suit levitating: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb4\xf0\x9f\x8f\xbe"),
        "man in suit levitating: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb4\xf0\x9f\x8f\xbf"),
        "man in suit levitating: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xaf"), "people with bunny ears"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xaf\xe2\x80\x8d\xe2\x99\x82"), "men with bunny ears"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xaf\xe2\x80\x8d\xe2\x99\x80"), "women with bunny ears"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96"), "person in steamy room"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbb"),
        "person in steamy room: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbc"),
        "person in steamy room: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbd"),
        "person in steamy room: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbe"),
        "person in steamy room: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbf"),
        "person in steamy room: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xe2\x80\x8d\xe2\x99\x82"), "man in steamy room"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man in steamy room: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man in steamy room: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man in steamy room: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man in steamy room: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man in steamy room: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xe2\x80\x8d\xe2\x99\x80"), "woman in steamy room"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman in steamy room: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman in steamy room: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman in steamy room: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman in steamy room: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x96\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman in steamy room: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97"), "person climbing"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbb"), "person climbing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbc"),
        "person climbing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbd"), "person climbing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbe"),
        "person climbing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbf"), "person climbing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xe2\x80\x8d\xe2\x99\x82"), "man climbing"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man climbing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man climbing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man climbing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man climbing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man climbing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xe2\x80\x8d\xe2\x99\x80"), "woman climbing"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman climbing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman climbing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman climbing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman climbing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x97\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman climbing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xb7"), "ninja"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xba"), "person fencing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x87"), "horse racing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x87\xf0\x9f\x8f\xbb"), "horse racing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x87\xf0\x9f\x8f\xbc"),
        "horse racing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x87\xf0\x9f\x8f\xbd"), "horse racing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x87\xf0\x9f\x8f\xbe"),
        "horse racing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x87\xf0\x9f\x8f\xbf"), "horse racing: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb7"), "skier"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x82"), "snowboarder"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x82\xf0\x9f\x8f\xbb"), "snowboarder: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x82\xf0\x9f\x8f\xbc"),
        "snowboarder: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x82\xf0\x9f\x8f\xbd"), "snowboarder: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x82\xf0\x9f\x8f\xbe"),
        "snowboarder: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x82\xf0\x9f\x8f\xbf"), "snowboarder: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c"), "person golfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbb"), "person golfing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbc"),
        "person golfing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbd"), "person golfing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbe"),
        "person golfing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbf"), "person golfing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x82"), "man golfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xe2\x80\x8d\xe2\x99\x82"), "man golfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man golfing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man golfing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man golfing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man golfing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man golfing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x80"), "woman golfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xe2\x80\x8d\xe2\x99\x80"), "woman golfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman golfing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman golfing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman golfing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman golfing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8c\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman golfing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84"), "person surfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbb"), "person surfing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbc"),
        "person surfing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbd"), "person surfing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbe"),
        "person surfing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbf"), "person surfing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xe2\x80\x8d\xe2\x99\x82"), "man surfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man surfing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man surfing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man surfing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man surfing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man surfing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xe2\x80\x8d\xe2\x99\x80"), "woman surfing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman surfing: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman surfing: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman surfing: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman surfing: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x84\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman surfing: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3"), "person rowing boat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbb"),
        "person rowing boat: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbc"),
        "person rowing boat: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbd"),
        "person rowing boat: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbe"),
        "person rowing boat: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbf"),
        "person rowing boat: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xe2\x80\x8d\xe2\x99\x82"), "man rowing boat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man rowing boat: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man rowing boat: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man rowing boat: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man rowing boat: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man rowing boat: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xe2\x80\x8d\xe2\x99\x80"), "woman rowing boat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman rowing boat: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman rowing boat: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman rowing boat: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman rowing boat: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa3\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman rowing boat: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a"), "person swimming"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbb"), "person swimming: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbc"),
        "person swimming: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbd"), "person swimming: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbe"),
        "person swimming: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbf"), "person swimming: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xe2\x80\x8d\xe2\x99\x82"), "man swimming"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man swimming: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man swimming: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man swimming: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man swimming: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man swimming: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xe2\x80\x8d\xe2\x99\x80"), "woman swimming"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman swimming: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman swimming: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman swimming: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman swimming: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8a\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman swimming: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9"), "person bouncing ball"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbb"), "person bouncing ball: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbc"),
        "person bouncing ball: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbd"),
        "person bouncing ball: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbe"),
        "person bouncing ball: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbf"), "person bouncing ball: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x82"), "man bouncing ball"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xe2\x80\x8d\xe2\x99\x82"), "man bouncing ball"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man bouncing ball: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man bouncing ball: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man bouncing ball: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man bouncing ball: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man bouncing ball: dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x80"),
        "woman bouncing ball"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xe2\x80\x8d\xe2\x99\x80"), "woman bouncing ball"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman bouncing ball: light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman bouncing ball: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman bouncing ball: medium skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman bouncing ball: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman bouncing ball: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b"), "person lifting weights"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbb"),
        "person lifting weights: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbc"),
        "person lifting weights: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbd"),
        "person lifting weights: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbe"),
        "person lifting weights: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbf"),
        "person lifting weights: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x82"),
        "man lifting weights"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xe2\x80\x8d\xe2\x99\x82"), "man lifting weights"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man lifting weights: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man lifting weights: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man lifting weights: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man lifting weights: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man lifting weights: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xef\xb8\x8f\xe2\x80\x8d\xe2\x99\x80"),
        "woman lifting weights"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xe2\x80\x8d\xe2\x99\x80"), "woman lifting weights"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman lifting weights: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman lifting weights: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman lifting weights: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman lifting weights: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8b\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman lifting weights: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4"), "person biking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbb"), "person biking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbc"),
        "person biking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbd"), "person biking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbe"),
        "person biking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbf"), "person biking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xe2\x80\x8d\xe2\x99\x82"), "man biking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man biking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man biking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man biking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man biking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man biking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xe2\x80\x8d\xe2\x99\x80"), "woman biking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman biking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman biking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman biking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman biking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb4\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman biking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5"), "person mountain biking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbb"),
        "person mountain biking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbc"),
        "person mountain biking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbd"),
        "person mountain biking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbe"),
        "person mountain biking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbf"),
        "person mountain biking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xe2\x80\x8d\xe2\x99\x82"), "man mountain biking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man mountain biking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man mountain biking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man mountain biking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man mountain biking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man mountain biking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xe2\x80\x8d\xe2\x99\x80"), "woman mountain biking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman mountain biking: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman mountain biking: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman mountain biking: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman mountain biking: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb5\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman mountain biking: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8"), "person cartwheeling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbb"),
        "person cartwheeling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbc"),
        "person cartwheeling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbd"),
        "person cartwheeling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbe"),
        "person cartwheeling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbf"),
        "person cartwheeling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xe2\x80\x8d\xe2\x99\x82"), "man cartwheeling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man cartwheeling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man cartwheeling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man cartwheeling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man cartwheeling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man cartwheeling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xe2\x80\x8d\xe2\x99\x80"), "woman cartwheeling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman cartwheeling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman cartwheeling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman cartwheeling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman cartwheeling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman cartwheeling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbc"), "people wrestling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbc\xe2\x80\x8d\xe2\x99\x82"), "men wrestling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbc\xe2\x80\x8d\xe2\x99\x80"), "women wrestling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd"), "person playing water polo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbb"),
        "person playing water polo: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbc"),
        "person playing water polo: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbd"),
        "person playing water polo: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbe"),
        "person playing water polo: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbf"),
        "person playing water polo: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xe2\x80\x8d\xe2\x99\x82"), "man playing water polo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man playing water polo: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man playing water polo: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man playing water polo: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man playing water polo: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man playing water polo: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xe2\x80\x8d\xe2\x99\x80"), "woman playing water polo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing water polo: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing water polo: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing water polo: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing water polo: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbd\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing water polo: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe"), "person playing handball"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbb"),
        "person playing handball: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbc"),
        "person playing handball: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbd"),
        "person playing handball: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbe"),
        "person playing handball: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbf"),
        "person playing handball: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xe2\x80\x8d\xe2\x99\x82"), "man playing handball"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man playing handball: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man playing handball: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man playing handball: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man playing handball: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man playing handball: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xe2\x80\x8d\xe2\x99\x80"), "woman playing handball"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing handball: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing handball: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing handball: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing handball: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbe\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman playing handball: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9"), "person juggling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbb"), "person juggling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbc"),
        "person juggling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbd"), "person juggling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbe"),
        "person juggling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbf"), "person juggling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xe2\x80\x8d\xe2\x99\x82"), "man juggling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man juggling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man juggling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man juggling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man juggling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man juggling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xe2\x80\x8d\xe2\x99\x80"), "woman juggling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman juggling: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman juggling: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman juggling: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman juggling: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xb9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman juggling: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98"), "person in lotus position"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbb"),
        "person in lotus position: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbc"),
        "person in lotus position: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbd"),
        "person in lotus position: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbe"),
        "person in lotus position: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbf"),
        "person in lotus position: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xe2\x80\x8d\xe2\x99\x82"), "man in lotus position"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x82"),
        "man in lotus position: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x82"),
        "man in lotus position: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x82"),
        "man in lotus position: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x82"),
        "man in lotus position: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x82"),
        "man in lotus position: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xe2\x80\x8d\xe2\x99\x80"), "woman in lotus position"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbb\xe2\x80\x8d\xe2\x99\x80"),
        "woman in lotus position: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbc\xe2\x80\x8d\xe2\x99\x80"),
        "woman in lotus position: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbd\xe2\x80\x8d\xe2\x99\x80"),
        "woman in lotus position: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbe\xe2\x80\x8d\xe2\x99\x80"),
        "woman in lotus position: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x98\xf0\x9f\x8f\xbf\xe2\x80\x8d\xe2\x99\x80"),
        "woman in lotus position: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x80"), "person taking bath"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x80\xf0\x9f\x8f\xbb"),
        "person taking bath: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x80\xf0\x9f\x8f\xbc"),
        "person taking bath: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x80\xf0\x9f\x8f\xbd"),
        "person taking bath: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x80\xf0\x9f\x8f\xbe"),
        "person taking bath: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x80\xf0\x9f\x8f\xbf"),
        "person taking bath: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8c"), "person in bed"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8c\xf0\x9f\x8f\xbb"), "person in bed: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8c\xf0\x9f\x8f\xbc"),
        "person in bed: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8c\xf0\x9f\x8f\xbd"), "person in bed: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8c\xf0\x9f\x8f\xbe"),
        "person in bed: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8c\xf0\x9f\x8f\xbf"), "person in bed: dark skin tone"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\xa7\x91\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d\xf0\x9f\xa7\x91"),
    "people holding hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb"),
        "people holding hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc"),
        "people holding hands: light skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd"),
        "people holding hands: light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe"),
        "people holding hands: light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf"),
        "people holding hands: light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb"),
        "people holding hands: medium-light skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc"),
        "people holding hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd"),
        "people holding hands: medium-light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe"),
        "people holding hands: medium-light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf"),
        "people holding hands: medium-light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb"),
        "people holding hands: medium skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc"),
        "people holding hands: medium skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd"),
        "people holding hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe"),
        "people holding hands: medium skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf"),
        "people holding hands: medium skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb"),
        "people holding hands: medium-dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc"),
        "people holding hands: medium-dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd"),
        "people holding hands: medium-dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe"),
        "people holding hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf"),
        "people holding hands: medium-dark skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbb"),
        "people holding hands: dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbc"),
        "people holding hands: dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbd"),
        "people holding hands: dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbe"),
        "people holding hands: dark skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\xa7\x91\xf0\x9f\x8f\xbf"),
        "people holding hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xad"), "women holding hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xad\xf0\x9f\x8f\xbb"),
        "women holding hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc"),
        "women holding hands: light skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd"),
        "women holding hands: light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe"),
        "women holding hands: light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf"),
        "women holding hands: light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb"),
        "women holding hands: medium-light skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xad\xf0\x9f\x8f\xbc"),
        "women holding hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd"),
        "women holding hands: medium-light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe"),
        "women holding hands: medium-light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf"),
        "women holding hands: medium-light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb"),
        "women holding hands: medium skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc"),
        "women holding hands: medium skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xad\xf0\x9f\x8f\xbd"),
        "women holding hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe"),
        "women holding hands: medium skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf"),
        "women holding hands: medium skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb"),
        "women holding hands: medium-dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc"),
        "women holding hands: medium-dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd"),
        "women holding hands: medium-dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xad\xf0\x9f\x8f\xbe"),
        "women holding hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf"),
        "women holding hands: medium-dark skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb"),
        "women holding hands: dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc"),
        "women holding hands: dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd"),
        "women holding hands: dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe"),
        "women holding hands: dark skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xad\xf0\x9f\x8f\xbf"),
        "women holding hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xab"), "woman and man holding hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xab\xf0\x9f\x8f\xbb"),
        "woman and man holding hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "woman and man holding hands: light skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "woman and man holding hands: light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "woman and man holding hands: light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "woman and man holding hands: light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "woman and man holding hands: medium-light skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xab\xf0\x9f\x8f\xbc"),
        "woman and man holding hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "woman and man holding hands: medium-light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "woman and man holding hands: medium-light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "woman and man holding hands: medium-light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "woman and man holding hands: medium skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "woman and man holding hands: medium skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xab\xf0\x9f\x8f\xbd"),
        "woman and man holding hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "woman and man holding hands: medium skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "woman and man holding hands: medium skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "woman and man holding hands: medium-dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "woman and man holding hands: medium-dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "woman and man holding hands: medium-dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xab\xf0\x9f\x8f\xbe"),
        "woman and man holding hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "woman and man holding hands: medium-dark skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "woman and man holding hands: dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "woman and man holding hands: dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "woman and man holding hands: dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "woman and man holding hands: dark skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xab\xf0\x9f\x8f\xbf"),
        "woman and man holding hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xac"), "men holding hands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xac\xf0\x9f\x8f\xbb"),
        "men holding hands: light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "men holding hands: light skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "men holding hands: light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "men holding hands: light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "men holding hands: light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "men holding hands: medium-light skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xac\xf0\x9f\x8f\xbc"),
        "men holding hands: medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "men holding hands: medium-light skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "men holding hands: medium-light skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "men holding hands: medium-light skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "men holding hands: medium skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "men holding hands: medium skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xac\xf0\x9f\x8f\xbd"),
        "men holding hands: medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "men holding hands: medium skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "men holding hands: medium skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "men holding hands: medium-dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "men holding hands: medium-dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "men holding hands: medium-dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xac\xf0\x9f\x8f\xbe"),
        "men holding hands: medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf"),
        "men holding hands: medium-dark skin tone, dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbb"),
        "men holding hands: dark skin tone, light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbc"),
        "men holding hands: dark skin tone, medium-light skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbd"),
        "men holding hands: dark skin tone, medium skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbf\xe2\x80\x8d\xf0\x9f\xa4\x9d\xe2\x80\x8d"
                          "\xf0\x9f\x91\xa8\xf0\x9f\x8f\xbe"),
        "men holding hands: dark skin tone, medium-dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xac\xf0\x9f\x8f\xbf"), "men holding hands: dark skin tone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x8f"), "kiss"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f"
                          "\x92\x8b\xe2\x80\x8d\xf0\x9f\x91\xa8"),
        "kiss: woman, man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xe2\x80\x8d\xf0\x9f\x92\x8b\xe2"
                          "\x80\x8d\xf0\x9f\x91\xa8"),
        "kiss: woman, man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9d\xa4\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f"
                          "\x92\x8b\xe2\x80\x8d\xf0\x9f\x91\xa8"),
        "kiss: man, man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9d\xa4\xe2\x80\x8d\xf0\x9f\x92\x8b\xe2"
                          "\x80\x8d\xf0\x9f\x91\xa8"),
        "kiss: man, man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f"
                          "\x92\x8b\xe2\x80\x8d\xf0\x9f\x91\xa9"),
        "kiss: woman, woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xe2\x80\x8d\xf0\x9f\x92\x8b\xe2"
                          "\x80\x8d\xf0\x9f\x91\xa9"),
        "kiss: woman, woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x91"), "couple with heart"},
  Emoji{QString::fromUtf8(
          "\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f\x91\xa8"),
        "couple with heart: woman, man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xe2\x80\x8d\xf0\x9f\x91\xa8"),
        "couple with heart: woman, man"},
  Emoji{QString::fromUtf8(
          "\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9d\xa4\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f\x91\xa8"),
        "couple with heart: man, man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xe2\x9d\xa4\xe2\x80\x8d\xf0\x9f\x91\xa8"),
        "couple with heart: man, man"},
  Emoji{QString::fromUtf8(
          "\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f\x91\xa9"),
        "couple with heart: woman, woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xe2\x9d\xa4\xe2\x80\x8d\xf0\x9f\x91\xa9"),
        "couple with heart: woman, woman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xaa"), "family"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: man, woman, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"),
    "family: man, woman, girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa6"),
        "family: man, woman, girl, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa6"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa6"),
        "family: man, woman, boy, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa7"),
        "family: man, woman, girl, girl"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: man, man, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa7"),
    "family: man, man, girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa7"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa6"),
        "family: man, man, girl, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa6"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa6"),
        "family: man, man, boy, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa7"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa7"),
        "family: man, man, girl, girl"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: woman, woman, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"),
    "family: woman, woman, girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa6"),
        "family: woman, woman, girl, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa6"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa6"),
        "family: woman, woman, boy, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"
                          "\xe2\x80\x8d\xf0\x9f\x91\xa7"),
        "family: woman, woman, girl, girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa6"), "family: man, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa6\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: man, boy, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa7"), "family: man, girl"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa7\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: man, girl, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa8\xe2\x80\x8d\xf0\x9f\x91\xa7\xe2\x80\x8d\xf0\x9f\x91\xa7"),
    "family: man, girl, girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa6"), "family: woman, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa6\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: woman, boy, boy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7"), "family: woman, girl"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7\xe2\x80\x8d\xf0\x9f\x91\xa6"),
    "family: woman, girl, boy"},
  Emoji{
    QString::fromUtf8("\xf0\x9f\x91\xa9\xe2\x80\x8d\xf0\x9f\x91\xa7\xe2\x80\x8d\xf0\x9f\x91\xa7"),
    "family: woman, girl, girl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xa3"), "speaking head"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa4"), "bust in silhouette"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa5"), "busts in silhouette"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x82"), "people hugging"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa3"), "footprints"},
};

const std::vector<Emoji> emoji::Provider::nature = {
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb5"), "monkey face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x92"), "monkey"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x8d"), "gorilla"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa7"), "orangutan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb6"), "dog face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x95"), "dog"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xae"), "guide dog"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x95\xe2\x80\x8d\xf0\x9f\xa6\xba"), "service dog"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa9"), "poodle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xba"), "wolf"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x8a"), "fox"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x9d"), "raccoon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb1"), "cat face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x88"), "cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x88\xe2\x80\x8d\xe2\xac\x9b"), "black cat"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x81"), "lion"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xaf"), "tiger face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x85"), "tiger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x86"), "leopard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb4"), "horse face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x8e"), "horse"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x84"), "unicorn"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x93"), "zebra"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x8c"), "deer"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xac"), "bison"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xae"), "cow face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x82"), "ox"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x83"), "water buffalo"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x84"), "cow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb7"), "pig face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x96"), "pig"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x97"), "boar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xbd"), "pig nose"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x8f"), "ram"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x91"), "ewe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x90"), "goat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xaa"), "camel"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xab"), "two-hump camel"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x99"), "llama"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x92"), "giraffe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x98"), "elephant"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa3"), "mammoth"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x8f"), "rhinoceros"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x9b"), "hippopotamus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xad"), "mouse face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x81"), "mouse"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x80"), "rat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb9"), "hamster"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb0"), "rabbit face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x87"), "rabbit"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xbf"), "chipmunk"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xab"), "beaver"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x94"), "hedgehog"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x87"), "bat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xbb"), "bear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xbb\xe2\x80\x8d\xe2\x9d\x84"), "polar bear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa8"), "koala"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xbc"), "panda"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa5"), "sloth"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa6"), "otter"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa8"), "skunk"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x98"), "kangaroo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa1"), "badger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xbe"), "paw prints"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x83"), "turkey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x94"), "chicken"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x93"), "rooster"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa3"), "hatching chick"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa4"), "baby chick"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa5"), "front-facing baby chick"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa6"), "bird"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa7"), "penguin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x8a"), "dove"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x85"), "eagle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x86"), "duck"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa2"), "swan"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x89"), "owl"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa4"), "dodo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb6"), "feather"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa9"), "flamingo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x9a"), "peacock"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x9c"), "parrot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb8"), "frog"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x8a"), "crocodile"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa2"), "turtle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x8e"), "lizard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x8d"), "snake"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb2"), "dragon face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x89"), "dragon"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x95"), "sauropod"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x96"), "T-Rex"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xb3"), "spouting whale"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x8b"), "whale"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xac"), "dolphin"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xad"), "seal"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x9f"), "fish"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa0"), "tropical fish"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\xa1"), "blowfish"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x88"), "shark"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x99"), "octopus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x9a"), "spiral shell"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x8c"), "snail"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x8b"), "butterfly"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x9b"), "bug"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x9c"), "ant"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x9d"), "honeybee"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb2"), "beetle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x90\x9e"), "lady beetle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x97"), "cricket"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb3"), "cockroach"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb7"), "spider"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb8"), "spider web"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x82"), "scorpion"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x9f"), "mosquito"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb0"), "fly"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb1"), "worm"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xa0"), "microbe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x90"), "bouquet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb8"), "cherry blossom"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xae"), "white flower"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb5"), "rosette"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb9"), "rose"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x80"), "wilted flower"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xba"), "hibiscus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xbb"), "sunflower"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xbc"), "blossom"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb7"), "tulip"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb1"), "seedling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb4"), "potted plant"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb2"), "evergreen tree"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb3"), "deciduous tree"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb4"), "palm tree"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb5"), "cactus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xbe"), "sheaf of rice"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xbf"), "herb"},
  Emoji{QString::fromUtf8("\xe2\x98\x98"), "shamrock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x80"), "four leaf clover"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x81"), "maple leaf"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x82"), "fallen leaf"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x83"), "leaf fluttering in wind"},
};

const std::vector<Emoji> emoji::Provider::food = {
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x87"), "grapes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x88"), "melon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x89"), "watermelon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x8a"), "tangerine"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x8b"), "lemon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x8c"), "banana"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x8d"), "pineapple"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xad"), "mango"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x8e"), "red apple"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x8f"), "green apple"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x90"), "pear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x91"), "peach"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x92"), "cherries"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x93"), "strawberry"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x90"), "blueberries"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x9d"), "kiwi fruit"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x85"), "tomato"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x92"), "olive"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa5"), "coconut"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x91"), "avocado"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x86"), "eggplant"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x94"), "potato"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x95"), "carrot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xbd"), "ear of corn"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb6"), "hot pepper"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x91"), "bell pepper"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x92"), "cucumber"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xac"), "leafy green"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa6"), "broccoli"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x84"), "garlic"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x85"), "onion"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x84"), "mushroom"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x9c"), "peanuts"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xb0"), "chestnut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x9e"), "bread"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x90"), "croissant"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x96"), "baguette bread"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x93"), "flatbread"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa8"), "pretzel"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xaf"), "bagel"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x9e"), "pancakes"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x87"), "waffle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x80"), "cheese wedge"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x96"), "meat on bone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x97"), "poultry leg"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa9"), "cut of meat"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x93"), "bacon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x94"), "hamburger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x9f"), "french fries"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x95"), "pizza"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xad"), "hot dog"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xaa"), "sandwich"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xae"), "taco"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xaf"), "burrito"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x94"), "tamale"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x99"), "stuffed flatbread"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x86"), "falafel"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x9a"), "egg"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb3"), "cooking"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x98"), "shallow pan of food"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb2"), "pot of food"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x95"), "fondue"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa3"), "bowl with spoon"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x97"), "green salad"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xbf"), "popcorn"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x88"), "butter"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x82"), "salt"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xab"), "canned food"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb1"), "bento box"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x98"), "rice cracker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x99"), "rice ball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x9a"), "cooked rice"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x9b"), "curry rice"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x9c"), "steaming bowl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\x9d"), "spaghetti"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa0"), "roasted sweet potato"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa2"), "oden"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa3"), "sushi"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa4"), "fried shrimp"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa5"), "fish cake with swirl"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xae"), "moon cake"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa1"), "dango"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x9f"), "dumpling"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa0"), "fortune cookie"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa1"), "takeout box"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x80"), "crab"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x9e"), "lobster"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x90"), "shrimp"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\x91"), "squid"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xaa"), "oyster"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa6"), "soft ice cream"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa7"), "shaved ice"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa8"), "ice cream"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xa9"), "doughnut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xaa"), "cookie"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x82"), "birthday cake"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb0"), "shortcake"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x81"), "cupcake"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa7"), "pie"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xab"), "chocolate bar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xac"), "candy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xad"), "lollipop"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xae"), "custard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xaf"), "honey pot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xbc"), "baby bottle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x9b"), "glass of milk"},
  Emoji{QString::fromUtf8("\xe2\x98\x95"), "hot beverage"},
  Emoji{QString::fromUtf8("\xf0\x9f\xab\x96"), "teapot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb5"), "teacup without handle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb6"), "sake"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xbe"), "bottle with popping cork"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb7"), "wine glass"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb8"), "cocktail glass"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb9"), "tropical drink"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xba"), "beer mug"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xbb"), "clinking beer mugs"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x82"), "clinking glasses"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x83"), "tumbler glass"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa4"), "cup with straw"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8b"), "bubble tea"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x83"), "beverage box"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x89"), "mate"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\x8a"), "ice"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xa2"), "chopsticks"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xbd"), "fork and knife with plate"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8d\xb4"), "fork and knife"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x84"), "spoon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xaa"), "kitchen knife"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xba"), "amphora"},
};

const std::vector<Emoji> emoji::Provider::activity = {
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x83"), "jack-o-lantern"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x84"), "Christmas tree"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x86"), "fireworks"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x87"), "sparkler"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa8"), "firecracker"},
  Emoji{QString::fromUtf8("\xe2\x9c\xa8"), "sparkles"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x88"), "balloon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x89"), "party popper"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x8a"), "confetti ball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x8b"), "tanabata tree"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x8d"), "pine decoration"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x8e"), "Japanese dolls"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x8f"), "carp streamer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x90"), "wind chime"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x91"), "moon viewing ceremony"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa7"), "red envelope"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x80"), "ribbon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x81"), "wrapped gift"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x97"), "reminder ribbon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x9f"), "admission tickets"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xab"), "ticket"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x96"), "military medal"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x86"), "trophy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x85"), "sports medal"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x87"), "1st place medal"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x88"), "2nd place medal"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x89"), "3rd place medal"},
  Emoji{QString::fromUtf8("\xe2\x9a\xbd"), "soccer ball"},
  Emoji{QString::fromUtf8("\xe2\x9a\xbe"), "baseball"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x8e"), "softball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x80"), "basketball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x90"), "volleyball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x88"), "american football"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x89"), "rugby football"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xbe"), "tennis"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x8f"), "flying disc"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb3"), "bowling"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8f"), "cricket game"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x91"), "field hockey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x92"), "ice hockey"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x8d"), "lacrosse"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x93"), "ping pong"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb8"), "badminton"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x8a"), "boxing glove"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x8b"), "martial arts uniform"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x85"), "goal net"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb3"), "flag in hole"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb8"), "ice skate"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa3"), "fishing pole"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa4\xbf"), "diving mask"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xbd"), "running shirt"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xbf"), "skis"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb7"), "sled"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x8c"), "curling stone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xaf"), "direct hit"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x80"), "yo-yo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x81"), "kite"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb1"), "pool 8 ball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xae"), "crystal ball"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x84"), "magic wand"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xbf"), "nazar amulet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xae"), "video game"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb9"), "joystick"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb0"), "slot machine"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb2"), "game die"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa9"), "puzzle piece"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb8"), "teddy bear"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x85"), "piñata"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x86"), "nesting dolls"},
  Emoji{QString::fromUtf8("\xe2\x99\xa0"), "spade suit"},
  Emoji{QString::fromUtf8("\xe2\x99\xa5"), "heart suit"},
  Emoji{QString::fromUtf8("\xe2\x99\xa6"), "diamond suit"},
  Emoji{QString::fromUtf8("\xe2\x99\xa3"), "club suit"},
  Emoji{QString::fromUtf8("\xe2\x99\x9f"), "chess pawn"},
  Emoji{QString::fromUtf8("\xf0\x9f\x83\x8f"), "joker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x80\x84"), "mahjong red dragon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb4"), "flower playing cards"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xad"), "performing arts"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\xbc"), "framed picture"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa8"), "artist palette"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb5"), "thread"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa1"), "sewing needle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb6"), "yarn"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa2"), "knot"},
};

const std::vector<Emoji> emoji::Provider::travel = {
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x8d"), "globe showing Europe-Africa"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x8e"), "globe showing Americas"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x8f"), "globe showing Asia-Australia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x90"), "globe with meridians"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xba"), "world map"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xbe"), "map of Japan"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xad"), "compass"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x94"), "snow-capped mountain"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb0"), "mountain"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x8b"), "volcano"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xbb"), "mount fuji"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x95"), "camping"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x96"), "beach with umbrella"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x9c"), "desert"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x9d"), "desert island"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x9e"), "national park"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x9f"), "stadium"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x9b"), "classical building"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x97"), "building construction"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb1"), "brick"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa8"), "rock"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xb5"), "wood"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x96"), "hut"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x98"), "houses"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x9a"), "derelict house"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa0"), "house"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa1"), "house with garden"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa2"), "office building"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa3"), "Japanese post office"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa4"), "post office"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa5"), "hospital"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa6"), "bank"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa8"), "hotel"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa9"), "love hotel"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xaa"), "convenience store"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xab"), "school"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xac"), "department store"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xad"), "factory"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xaf"), "Japanese castle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb0"), "castle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x92"), "wedding"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xbc"), "Tokyo tower"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xbd"), "Statue of Liberty"},
  Emoji{QString::fromUtf8("\xe2\x9b\xaa"), "church"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x8c"), "mosque"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x95"), "hindu temple"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x8d"), "synagogue"},
  Emoji{QString::fromUtf8("\xe2\x9b\xa9"), "shinto shrine"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x8b"), "kaaba"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb2"), "fountain"},
  Emoji{QString::fromUtf8("\xe2\x9b\xba"), "tent"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x81"), "foggy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x83"), "night with stars"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x99"), "cityscape"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x84"), "sunrise over mountains"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x85"), "sunrise"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x86"), "cityscape at dusk"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x87"), "sunset"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x89"), "bridge at night"},
  Emoji{QString::fromUtf8("\xe2\x99\xa8"), "hot springs"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa0"), "carousel horse"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa1"), "ferris wheel"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa2"), "roller coaster"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x88"), "barber pole"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xaa"), "circus tent"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x82"), "locomotive"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x83"), "railway car"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x84"), "high-speed train"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x85"), "bullet train"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x86"), "train"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x87"), "metro"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x88"), "light rail"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x89"), "station"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x8a"), "tram"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x9d"), "monorail"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x9e"), "mountain railway"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x8b"), "tram car"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x8c"), "bus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x8d"), "oncoming bus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x8e"), "trolleybus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x90"), "minibus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x91"), "ambulance"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x92"), "fire engine"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x93"), "police car"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x94"), "oncoming police car"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x95"), "taxi"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x96"), "oncoming taxi"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x97"), "automobile"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x98"), "oncoming automobile"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x99"), "sport utility vehicle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xbb"), "pickup truck"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x9a"), "delivery truck"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x9b"), "articulated lorry"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x9c"), "tractor"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8e"), "racing car"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x8d"), "motorcycle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb5"), "motor scooter"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbd"), "manual wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xbc"), "motorized wheelchair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xba"), "auto rickshaw"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb2"), "bicycle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb4"), "kick scooter"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb9"), "skateboard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xbc"), "roller skate"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x8f"), "bus stop"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa3"), "motorway"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa4"), "railway track"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa2"), "oil drum"},
  Emoji{QString::fromUtf8("\xe2\x9b\xbd"), "fuel pump"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa8"), "police car light"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa5"), "horizontal traffic light"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa6"), "vertical traffic light"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x91"), "stop sign"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa7"), "construction"},
  Emoji{QString::fromUtf8("\xe2\x9a\x93"), "anchor"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb5"), "sailboat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb6"), "canoe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa4"), "speedboat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb3"), "passenger ship"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb4"), "ferry"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa5"), "motor boat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa2"), "ship"},
  Emoji{QString::fromUtf8("\xe2\x9c\x88"), "airplane"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa9"), "small airplane"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xab"), "airplane departure"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xac"), "airplane arrival"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x82"), "parachute"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xba"), "seat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x81"), "helicopter"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x9f"), "suspension railway"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa0"), "mountain cableway"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa1"), "aerial tramway"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb0"), "satellite"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\x80"), "rocket"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xb8"), "flying saucer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8e"), "bellhop bell"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb3"), "luggage"},
  Emoji{QString::fromUtf8("\xe2\x8c\x9b"), "hourglass done"},
  Emoji{QString::fromUtf8("\xe2\x8f\xb3"), "hourglass not done"},
  Emoji{QString::fromUtf8("\xe2\x8c\x9a"), "watch"},
  Emoji{QString::fromUtf8("\xe2\x8f\xb0"), "alarm clock"},
  Emoji{QString::fromUtf8("\xe2\x8f\xb1"), "stopwatch"},
  Emoji{QString::fromUtf8("\xe2\x8f\xb2"), "timer clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb0"), "mantelpiece clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x9b"), "twelve o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa7"), "twelve-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x90"), "one o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x9c"), "one-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x91"), "two o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x9d"), "two-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x92"), "three o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x9e"), "three-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x93"), "four o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x9f"), "four-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x94"), "five o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa0"), "five-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x95"), "six o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa1"), "six-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x96"), "seven o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa2"), "seven-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x97"), "eight o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa3"), "eight-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x98"), "nine o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa4"), "nine-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x99"), "ten o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa5"), "ten-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x9a"), "eleven o’clock"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xa6"), "eleven-thirty"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x91"), "new moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x92"), "waxing crescent moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x93"), "first quarter moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x94"), "waxing gibbous moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x95"), "full moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x96"), "waning gibbous moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x97"), "last quarter moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x98"), "waning crescent moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x99"), "crescent moon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x9a"), "new moon face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x9b"), "first quarter moon face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x9c"), "last quarter moon face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa1"), "thermometer"},
  Emoji{QString::fromUtf8("\xe2\x98\x80"), "sun"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x9d"), "full moon face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x9e"), "sun with face"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x90"), "ringed planet"},
  Emoji{QString::fromUtf8("\xe2\xad\x90"), "star"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x9f"), "glowing star"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa0"), "shooting star"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x8c"), "milky way"},
  Emoji{QString::fromUtf8("\xe2\x98\x81"), "cloud"},
  Emoji{QString::fromUtf8("\xe2\x9b\x85"), "sun behind cloud"},
  Emoji{QString::fromUtf8("\xe2\x9b\x88"), "cloud with lightning and rain"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa4"), "sun behind small cloud"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa5"), "sun behind large cloud"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa6"), "sun behind rain cloud"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa7"), "cloud with rain"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa8"), "cloud with snow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xa9"), "cloud with lightning"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xaa"), "tornado"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xab"), "fog"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\xac"), "wind face"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x80"), "cyclone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x88"), "rainbow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x82"), "closed umbrella"},
  Emoji{QString::fromUtf8("\xe2\x98\x82"), "umbrella"},
  Emoji{QString::fromUtf8("\xe2\x98\x94"), "umbrella with rain drops"},
  Emoji{QString::fromUtf8("\xe2\x9b\xb1"), "umbrella on ground"},
  Emoji{QString::fromUtf8("\xe2\x9a\xa1"), "high voltage"},
  Emoji{QString::fromUtf8("\xe2\x9d\x84"), "snowflake"},
  Emoji{QString::fromUtf8("\xe2\x98\x83"), "snowman"},
  Emoji{QString::fromUtf8("\xe2\x9b\x84"), "snowman without snow"},
  Emoji{QString::fromUtf8("\xe2\x98\x84"), "comet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa5"), "fire"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa7"), "droplet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8c\x8a"), "water wave"},
};

const std::vector<Emoji> emoji::Provider::objects = {
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x93"), "glasses"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xb6"), "sunglasses"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xbd"), "goggles"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xbc"), "lab coat"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xba"), "safety vest"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x94"), "necktie"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x95"), "t-shirt"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x96"), "jeans"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa3"), "scarf"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa4"), "gloves"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa5"), "coat"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa6"), "socks"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x97"), "dress"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x98"), "kimono"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xbb"), "sari"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb1"), "one-piece swimsuit"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb2"), "briefs"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb3"), "shorts"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x99"), "bikini"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x9a"), "woman’s clothes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x9b"), "purse"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x9c"), "handbag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x9d"), "clutch bag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8d"), "shopping bags"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x92"), "backpack"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb4"), "thong sandal"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x9e"), "man’s shoe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x9f"), "running shoe"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xbe"), "hiking boot"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\xbf"), "flat shoe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa0"), "high-heeled shoe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa1"), "woman’s sandal"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb0"), "ballet shoes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\xa2"), "woman’s boot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x91"), "crown"},
  Emoji{QString::fromUtf8("\xf0\x9f\x91\x92"), "woman’s hat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa9"), "top hat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x93"), "graduation cap"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xa2"), "billed cap"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x96"), "military helmet"},
  Emoji{QString::fromUtf8("\xe2\x9b\x91"), "rescue worker’s helmet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xbf"), "prayer beads"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x84"), "lipstick"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x8d"), "ring"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x8e"), "gem stone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x87"), "muted speaker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x88"), "speaker low volume"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x89"), "speaker medium volume"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x8a"), "speaker high volume"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa2"), "loudspeaker"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa3"), "megaphone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xaf"), "postal horn"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x94"), "bell"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x95"), "bell with slash"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xbc"), "musical score"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb5"), "musical note"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb6"), "musical notes"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x99"), "studio microphone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x9a"), "level slider"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x9b"), "control knobs"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa4"), "microphone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa7"), "headphone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xbb"), "radio"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb7"), "saxophone"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x97"), "accordion"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb8"), "guitar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xb9"), "musical keyboard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xba"), "trumpet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xbb"), "violin"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x95"), "banjo"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa5\x81"), "drum"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x98"), "long drum"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb1"), "mobile phone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb2"), "mobile phone with arrow"},
  Emoji{QString::fromUtf8("\xe2\x98\x8e"), "telephone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x9e"), "telephone receiver"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x9f"), "pager"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa0"), "fax machine"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x8b"), "battery"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x8c"), "electric plug"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xbb"), "laptop"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\xa5"), "desktop computer"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\xa8"), "printer"},
  Emoji{QString::fromUtf8("\xe2\x8c\xa8"), "keyboard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\xb1"), "computer mouse"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\xb2"), "trackball"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xbd"), "computer disk"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xbe"), "floppy disk"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xbf"), "optical disk"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x80"), "dvd"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xae"), "abacus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa5"), "movie camera"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x9e"), "film frames"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xbd"), "film projector"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xac"), "clapper board"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xba"), "television"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb7"), "camera"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb8"), "camera with flash"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb9"), "video camera"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xbc"), "videocassette"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x8d"), "magnifying glass tilted left"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x8e"), "magnifying glass tilted right"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\xaf"), "candle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa1"), "light bulb"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa6"), "flashlight"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xae"), "red paper lantern"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x94"), "diya lamp"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x94"), "notebook with decorative cover"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x95"), "closed book"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x96"), "open book"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x97"), "green book"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x98"), "blue book"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x99"), "orange book"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x9a"), "books"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x93"), "notebook"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x92"), "ledger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x83"), "page with curl"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x9c"), "scroll"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x84"), "page facing up"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb0"), "newspaper"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x9e"), "rolled-up newspaper"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x91"), "bookmark tabs"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x96"), "bookmark"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb7"), "label"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb0"), "money bag"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x99"), "coin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb4"), "yen banknote"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb5"), "dollar banknote"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb6"), "euro banknote"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb7"), "pound banknote"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb8"), "money with wings"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb3"), "credit card"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xbe"), "receipt"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb9"), "chart increasing with yen"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb1"), "currency exchange"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xb2"), "heavy dollar sign"},
  Emoji{QString::fromUtf8("\xe2\x9c\x89"), "envelope"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa7"), "e-mail"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa8"), "incoming envelope"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa9"), "envelope with arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa4"), "outbox tray"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa5"), "inbox tray"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa6"), "package"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xab"), "closed mailbox with raised flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xaa"), "closed mailbox with lowered flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xac"), "open mailbox with raised flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xad"), "open mailbox with lowered flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xae"), "postbox"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xb3"), "ballot box with ballot"},
  Emoji{QString::fromUtf8("\xe2\x9c\x8f"), "pencil"},
  Emoji{QString::fromUtf8("\xe2\x9c\x92"), "black nib"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x8b"), "fountain pen"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x8a"), "pen"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x8c"), "paintbrush"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x8d"), "crayon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x9d"), "memo"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xbc"), "briefcase"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x81"), "file folder"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x82"), "open file folder"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x82"), "card index dividers"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x85"), "calendar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x86"), "tear-off calendar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x92"), "spiral notepad"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x93"), "spiral calendar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x87"), "card index"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x88"), "chart increasing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x89"), "chart decreasing"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x8a"), "bar chart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x8b"), "clipboard"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x8c"), "pushpin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x8d"), "round pushpin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x8e"), "paperclip"},
  Emoji{QString::fromUtf8("\xf0\x9f\x96\x87"), "linked paperclips"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x8f"), "straight ruler"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x90"), "triangular ruler"},
  Emoji{QString::fromUtf8("\xe2\x9c\x82"), "scissors"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x83"), "card file box"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x84"), "file cabinet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x91"), "wastebasket"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x92"), "locked"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x93"), "unlocked"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x8f"), "locked with pen"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x90"), "locked with key"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x91"), "key"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x9d"), "old key"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa8"), "hammer"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x93"), "axe"},
  Emoji{QString::fromUtf8("\xe2\x9b\x8f"), "pick"},
  Emoji{QString::fromUtf8("\xe2\x9a\x92"), "hammer and pick"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa0"), "hammer and wrench"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xa1"), "dagger"},
  Emoji{QString::fromUtf8("\xe2\x9a\x94"), "crossed swords"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xab"), "pistol"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x83"), "boomerang"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb9"), "bow and arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\xa1"), "shield"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x9a"), "carpentry saw"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa7"), "wrench"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x9b"), "screwdriver"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa9"), "nut and bolt"},
  Emoji{QString::fromUtf8("\xe2\x9a\x99"), "gear"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\x9c"), "clamp"},
  Emoji{QString::fromUtf8("\xe2\x9a\x96"), "balance scale"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa6\xaf"), "probing cane"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x97"), "link"},
  Emoji{QString::fromUtf8("\xe2\x9b\x93"), "chains"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x9d"), "hook"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb0"), "toolbox"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb2"), "magnet"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x9c"), "ladder"},
  Emoji{QString::fromUtf8("\xe2\x9a\x97"), "alembic"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xaa"), "test tube"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xab"), "petri dish"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xac"), "dna"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xac"), "microscope"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xad"), "telescope"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xa1"), "satellite antenna"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x89"), "syringe"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb8"), "drop of blood"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\x8a"), "pill"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xb9"), "adhesive bandage"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa9\xba"), "stethoscope"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xaa"), "door"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x97"), "elevator"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x9e"), "mirror"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x9f"), "window"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8f"), "bed"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x8b"), "couch and lamp"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x91"), "chair"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xbd"), "toilet"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa0"), "plunger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xbf"), "shower"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x81"), "bathtub"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa4"), "mouse trap"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\x92"), "razor"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb4"), "lotion bottle"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb7"), "safety pin"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xb9"), "broom"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xba"), "basket"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xbb"), "roll of paper"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa3"), "bucket"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xbc"), "soap"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa5"), "toothbrush"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xbd"), "sponge"},
  Emoji{QString::fromUtf8("\xf0\x9f\xa7\xaf"), "fire extinguisher"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x92"), "shopping cart"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xac"), "cigarette"},
  Emoji{QString::fromUtf8("\xe2\x9a\xb0"), "coffin"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa6"), "headstone"},
  Emoji{QString::fromUtf8("\xe2\x9a\xb1"), "funeral urn"},
  Emoji{QString::fromUtf8("\xf0\x9f\x97\xbf"), "moai"},
  Emoji{QString::fromUtf8("\xf0\x9f\xaa\xa7"), "placard"},
};

const std::vector<Emoji> emoji::Provider::symbols = {
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xa7"), "ATM sign"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xae"), "litter in bin sign"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb0"), "potable water"},
  Emoji{QString::fromUtf8("\xe2\x99\xbf"), "wheelchair symbol"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb9"), "men’s room"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xba"), "women’s room"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xbb"), "restroom"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xbc"), "baby symbol"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xbe"), "water closet"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x82"), "passport control"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x83"), "customs"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x84"), "baggage claim"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x85"), "left luggage"},
  Emoji{QString::fromUtf8("\xe2\x9a\xa0"), "warning"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb8"), "children crossing"},
  Emoji{QString::fromUtf8("\xe2\x9b\x94"), "no entry"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xab"), "prohibited"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb3"), "no bicycles"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xad"), "no smoking"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xaf"), "no littering"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb1"), "non-potable water"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xb7"), "no pedestrians"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb5"), "no mobile phones"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x9e"), "no one under eighteen"},
  Emoji{QString::fromUtf8("\xe2\x98\xa2"), "radioactive"},
  Emoji{QString::fromUtf8("\xe2\x98\xa3"), "biohazard"},
  Emoji{QString::fromUtf8("\xe2\xac\x86"), "up arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\x97"), "up-right arrow"},
  Emoji{QString::fromUtf8("\xe2\x9e\xa1"), "right arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\x98"), "down-right arrow"},
  Emoji{QString::fromUtf8("\xe2\xac\x87"), "down arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\x99"), "down-left arrow"},
  Emoji{QString::fromUtf8("\xe2\xac\x85"), "left arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\x96"), "up-left arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\x95"), "up-down arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\x94"), "left-right arrow"},
  Emoji{QString::fromUtf8("\xe2\x86\xa9"), "right arrow curving left"},
  Emoji{QString::fromUtf8("\xe2\x86\xaa"), "left arrow curving right"},
  Emoji{QString::fromUtf8("\xe2\xa4\xb4"), "right arrow curving up"},
  Emoji{QString::fromUtf8("\xe2\xa4\xb5"), "right arrow curving down"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x83"), "clockwise vertical arrows"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x84"), "counterclockwise arrows button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x99"), "BACK arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x9a"), "END arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x9b"), "ON! arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x9c"), "SOON arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x9d"), "TOP arrow"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9b\x90"), "place of worship"},
  Emoji{QString::fromUtf8("\xe2\x9a\x9b"), "atom symbol"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x89"), "om"},
  Emoji{QString::fromUtf8("\xe2\x9c\xa1"), "star of David"},
  Emoji{QString::fromUtf8("\xe2\x98\xb8"), "wheel of dharma"},
  Emoji{QString::fromUtf8("\xe2\x98\xaf"), "yin yang"},
  Emoji{QString::fromUtf8("\xe2\x9c\x9d"), "latin cross"},
  Emoji{QString::fromUtf8("\xe2\x98\xa6"), "orthodox cross"},
  Emoji{QString::fromUtf8("\xe2\x98\xaa"), "star and crescent"},
  Emoji{QString::fromUtf8("\xe2\x98\xae"), "peace symbol"},
  Emoji{QString::fromUtf8("\xf0\x9f\x95\x8e"), "menorah"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xaf"), "dotted six-pointed star"},
  Emoji{QString::fromUtf8("\xe2\x99\x88"), "Aries"},
  Emoji{QString::fromUtf8("\xe2\x99\x89"), "Taurus"},
  Emoji{QString::fromUtf8("\xe2\x99\x8a"), "Gemini"},
  Emoji{QString::fromUtf8("\xe2\x99\x8b"), "Cancer"},
  Emoji{QString::fromUtf8("\xe2\x99\x8c"), "Leo"},
  Emoji{QString::fromUtf8("\xe2\x99\x8d"), "Virgo"},
  Emoji{QString::fromUtf8("\xe2\x99\x8e"), "Libra"},
  Emoji{QString::fromUtf8("\xe2\x99\x8f"), "Scorpio"},
  Emoji{QString::fromUtf8("\xe2\x99\x90"), "Sagittarius"},
  Emoji{QString::fromUtf8("\xe2\x99\x91"), "Capricorn"},
  Emoji{QString::fromUtf8("\xe2\x99\x92"), "Aquarius"},
  Emoji{QString::fromUtf8("\xe2\x99\x93"), "Pisces"},
  Emoji{QString::fromUtf8("\xe2\x9b\x8e"), "Ophiuchus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x80"), "shuffle tracks button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x81"), "repeat button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x82"), "repeat single button"},
  Emoji{QString::fromUtf8("\xe2\x96\xb6"), "play button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xa9"), "fast-forward button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xad"), "next track button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xaf"), "play or pause button"},
  Emoji{QString::fromUtf8("\xe2\x97\x80"), "reverse button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xaa"), "fast reverse button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xae"), "last track button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xbc"), "upwards button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xab"), "fast up button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xbd"), "downwards button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xac"), "fast down button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xb8"), "pause button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xb9"), "stop button"},
  Emoji{QString::fromUtf8("\xe2\x8f\xba"), "record button"},
  Emoji{QString::fromUtf8("\xe2\x8f\x8f"), "eject button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\xa6"), "cinema"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x85"), "dim button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x86"), "bright button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb6"), "antenna bars"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb3"), "vibration mode"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\xb4"), "mobile phone off"},
  Emoji{QString::fromUtf8("\xe2\x99\x80"), "female sign"},
  Emoji{QString::fromUtf8("\xe2\x99\x82"), "male sign"},
  Emoji{QString::fromUtf8("\xe2\x9a\xa7"), "transgender symbol"},
  Emoji{QString::fromUtf8("\xe2\x9a\x95"), "medical symbol"},
  Emoji{QString::fromUtf8("\xe2\x99\xbe"), "infinity"},
  Emoji{QString::fromUtf8("\xe2\x99\xbb"), "recycling symbol"},
  Emoji{QString::fromUtf8("\xe2\x9a\x9c"), "fleur-de-lis"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb1"), "trident emblem"},
  Emoji{QString::fromUtf8("\xf0\x9f\x93\x9b"), "name badge"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb0"), "Japanese symbol for beginner"},
  Emoji{QString::fromUtf8("\xe2\xad\x95"), "hollow red circle"},
  Emoji{QString::fromUtf8("\xe2\x9c\x85"), "check mark button"},
  Emoji{QString::fromUtf8("\xe2\x98\x91"), "check box with check"},
  Emoji{QString::fromUtf8("\xe2\x9c\x94"), "check mark"},
  Emoji{QString::fromUtf8("\xe2\x9c\x96"), "multiplication sign"},
  Emoji{QString::fromUtf8("\xe2\x9d\x8c"), "cross mark"},
  Emoji{QString::fromUtf8("\xe2\x9d\x8e"), "cross mark button"},
  Emoji{QString::fromUtf8("\xe2\x9e\x95"), "plus sign"},
  Emoji{QString::fromUtf8("\xe2\x9e\x96"), "minus sign"},
  Emoji{QString::fromUtf8("\xe2\x9e\x97"), "division sign"},
  Emoji{QString::fromUtf8("\xe2\x9e\xb0"), "curly loop"},
  Emoji{QString::fromUtf8("\xe2\x9e\xbf"), "double curly loop"},
  Emoji{QString::fromUtf8("\xe3\x80\xbd"), "part alternation mark"},
  Emoji{QString::fromUtf8("\xe2\x9c\xb3"), "eight-spoked asterisk"},
  Emoji{QString::fromUtf8("\xe2\x9c\xb4"), "eight-pointed star"},
  Emoji{QString::fromUtf8("\xe2\x9d\x87"), "sparkle"},
  Emoji{QString::fromUtf8("\xe2\x80\xbc"), "double exclamation mark"},
  Emoji{QString::fromUtf8("\xe2\x81\x89"), "exclamation question mark"},
  Emoji{QString::fromUtf8("\xe2\x9d\x93"), "question mark"},
  Emoji{QString::fromUtf8("\xe2\x9d\x94"), "white question mark"},
  Emoji{QString::fromUtf8("\xe2\x9d\x95"), "white exclamation mark"},
  Emoji{QString::fromUtf8("\xe2\x9d\x97"), "exclamation mark"},
  Emoji{QString::fromUtf8("\xe3\x80\xb0"), "wavy dash"},
  Emoji{QString::fromUtf8("\xc2\xa9"), "copyright"},
  Emoji{QString::fromUtf8("\xc2\xae"), "registered"},
  Emoji{QString::fromUtf8("\xe2\x84\xa2"), "trade mark"},
  Emoji{QString::fromUtf8("#\xef\xb8\x8f\xe2\x83\xa3"), "keycap: #"},
  Emoji{QString::fromUtf8("#\xe2\x83\xa3"), "keycap: #"},
  Emoji{QString::fromUtf8("*\xef\xb8\x8f\xe2\x83\xa3"), "keycap: *"},
  Emoji{QString::fromUtf8("*\xe2\x83\xa3"), "keycap: *"},
  Emoji{QString::fromUtf8("0\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 0"},
  Emoji{QString::fromUtf8("0\xe2\x83\xa3"), "keycap: 0"},
  Emoji{QString::fromUtf8("1\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 1"},
  Emoji{QString::fromUtf8("1\xe2\x83\xa3"), "keycap: 1"},
  Emoji{QString::fromUtf8("2\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 2"},
  Emoji{QString::fromUtf8("2\xe2\x83\xa3"), "keycap: 2"},
  Emoji{QString::fromUtf8("3\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 3"},
  Emoji{QString::fromUtf8("3\xe2\x83\xa3"), "keycap: 3"},
  Emoji{QString::fromUtf8("4\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 4"},
  Emoji{QString::fromUtf8("4\xe2\x83\xa3"), "keycap: 4"},
  Emoji{QString::fromUtf8("5\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 5"},
  Emoji{QString::fromUtf8("5\xe2\x83\xa3"), "keycap: 5"},
  Emoji{QString::fromUtf8("6\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 6"},
  Emoji{QString::fromUtf8("6\xe2\x83\xa3"), "keycap: 6"},
  Emoji{QString::fromUtf8("7\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 7"},
  Emoji{QString::fromUtf8("7\xe2\x83\xa3"), "keycap: 7"},
  Emoji{QString::fromUtf8("8\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 8"},
  Emoji{QString::fromUtf8("8\xe2\x83\xa3"), "keycap: 8"},
  Emoji{QString::fromUtf8("9\xef\xb8\x8f\xe2\x83\xa3"), "keycap: 9"},
  Emoji{QString::fromUtf8("9\xe2\x83\xa3"), "keycap: 9"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x9f"), "keycap: 10"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa0"), "input latin uppercase"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa1"), "input latin lowercase"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa2"), "input numbers"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa3"), "input symbols"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xa4"), "input latin letters"},
  Emoji{QString::fromUtf8("\xf0\x9f\x85\xb0"), "A button (blood type)"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x8e"), "AB button (blood type)"},
  Emoji{QString::fromUtf8("\xf0\x9f\x85\xb1"), "B button (blood type)"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x91"), "CL button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x92"), "COOL button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x93"), "FREE button"},
  Emoji{QString::fromUtf8("\xe2\x84\xb9"), "information"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x94"), "ID button"},
  Emoji{QString::fromUtf8("\xe2\x93\x82"), "circled M"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x95"), "NEW button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x96"), "NG button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x85\xbe"), "O button (blood type)"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x97"), "OK button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x85\xbf"), "P button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x98"), "SOS button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x99"), "UP! button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x86\x9a"), "VS button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\x81"), "Japanese “here” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\x82"), "Japanese “service charge” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb7"), "Japanese “monthly amount” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb6"), "Japanese “not free of charge” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xaf"), "Japanese “reserved” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x89\x90"), "Japanese “bargain” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb9"), "Japanese “discount” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\x9a"), "Japanese “free of charge” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb2"), "Japanese “prohibited” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x89\x91"), "Japanese “acceptable” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb8"), "Japanese “application” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb4"), "Japanese “passing grade” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb3"), "Japanese “vacancy” button"},
  Emoji{QString::fromUtf8("\xe3\x8a\x97"), "Japanese “congratulations” button"},
  Emoji{QString::fromUtf8("\xe3\x8a\x99"), "Japanese “secret” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xba"), "Japanese “open for business” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x88\xb5"), "Japanese “no vacancy” button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb4"), "red circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa0"), "orange circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa1"), "yellow circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa2"), "green circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb5"), "blue circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa3"), "purple circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa4"), "brown circle"},
  Emoji{QString::fromUtf8("\xe2\x9a\xab"), "black circle"},
  Emoji{QString::fromUtf8("\xe2\x9a\xaa"), "white circle"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa5"), "red square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa7"), "orange square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa8"), "yellow square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa9"), "green square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xa6"), "blue square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xaa"), "purple square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9f\xab"), "brown square"},
  Emoji{QString::fromUtf8("\xe2\xac\x9b"), "black large square"},
  Emoji{QString::fromUtf8("\xe2\xac\x9c"), "white large square"},
  Emoji{QString::fromUtf8("\xe2\x97\xbc"), "black medium square"},
  Emoji{QString::fromUtf8("\xe2\x97\xbb"), "white medium square"},
  Emoji{QString::fromUtf8("\xe2\x97\xbe"), "black medium-small square"},
  Emoji{QString::fromUtf8("\xe2\x97\xbd"), "white medium-small square"},
  Emoji{QString::fromUtf8("\xe2\x96\xaa"), "black small square"},
  Emoji{QString::fromUtf8("\xe2\x96\xab"), "white small square"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb6"), "large orange diamond"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb7"), "large blue diamond"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb8"), "small orange diamond"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb9"), "small blue diamond"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xba"), "red triangle pointed up"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xbb"), "red triangle pointed down"},
  Emoji{QString::fromUtf8("\xf0\x9f\x92\xa0"), "diamond with a dot"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\x98"), "radio button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb3"), "white square button"},
  Emoji{QString::fromUtf8("\xf0\x9f\x94\xb2"), "black square button"},
};

const std::vector<Emoji> emoji::Provider::flags = {
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\x81"), "chequered flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x9a\xa9"), "triangular flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8e\x8c"), "crossed flags"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb4"), "black flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb3"), "white flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb3\xef\xb8\x8f\xe2\x80\x8d\xf0\x9f\x8c\x88"),
        "rainbow flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb3\xe2\x80\x8d\xf0\x9f\x8c\x88"), "rainbow flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb3\xef\xb8\x8f\xe2\x80\x8d\xe2\x9a\xa7"),
        "transgender flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb3\xe2\x80\x8d\xe2\x9a\xa7"), "transgender flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb4\xe2\x80\x8d\xe2\x98\xa0"), "pirate flag"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xa8"), "flag: Ascension Island"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xa9"), "flag: Andorra"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xaa"), "flag: United Arab Emirates"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xab"), "flag: Afghanistan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xac"), "flag: Antigua & Barbuda"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xae"), "flag: Anguilla"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb1"), "flag: Albania"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb2"), "flag: Armenia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb4"), "flag: Angola"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb6"), "flag: Antarctica"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb7"), "flag: Argentina"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb8"), "flag: American Samoa"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xb9"), "flag: Austria"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xba"), "flag: Australia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xbc"), "flag: Aruba"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xbd"), "flag: Åland Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa6\xf0\x9f\x87\xbf"), "flag: Azerbaijan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xa6"), "flag: Bosnia & Herzegovina"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xa7"), "flag: Barbados"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xa9"), "flag: Bangladesh"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xaa"), "flag: Belgium"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xab"), "flag: Burkina Faso"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xac"), "flag: Bulgaria"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xad"), "flag: Bahrain"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xae"), "flag: Burundi"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xaf"), "flag: Benin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb1"), "flag: St. Barthélemy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb2"), "flag: Bermuda"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb3"), "flag: Brunei"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb4"), "flag: Bolivia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb6"), "flag: Caribbean Netherlands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb7"), "flag: Brazil"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb8"), "flag: Bahamas"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xb9"), "flag: Bhutan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xbb"), "flag: Bouvet Island"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xbc"), "flag: Botswana"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xbe"), "flag: Belarus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa7\xf0\x9f\x87\xbf"), "flag: Belize"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xa6"), "flag: Canada"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xa8"), "flag: Cocos (Keeling) Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xa9"), "flag: Congo - Kinshasa"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xab"), "flag: Central African Republic"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xac"), "flag: Congo - Brazzaville"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xad"), "flag: Switzerland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xae"), "flag: Côte d’Ivoire"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb0"), "flag: Cook Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb1"), "flag: Chile"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb2"), "flag: Cameroon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb3"), "flag: China"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb4"), "flag: Colombia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb5"), "flag: Clipperton Island"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xb7"), "flag: Costa Rica"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xba"), "flag: Cuba"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xbb"), "flag: Cape Verde"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xbc"), "flag: Curaçao"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xbd"), "flag: Christmas Island"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xbe"), "flag: Cyprus"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa8\xf0\x9f\x87\xbf"), "flag: Czechia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xaa"), "flag: Germany"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xac"), "flag: Diego Garcia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xaf"), "flag: Djibouti"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xb0"), "flag: Denmark"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xb2"), "flag: Dominica"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xb4"), "flag: Dominican Republic"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xa9\xf0\x9f\x87\xbf"), "flag: Algeria"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xa6"), "flag: Ceuta & Melilla"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xa8"), "flag: Ecuador"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xaa"), "flag: Estonia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xac"), "flag: Egypt"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xad"), "flag: Western Sahara"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xb7"), "flag: Eritrea"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xb8"), "flag: Spain"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xb9"), "flag: Ethiopia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaa\xf0\x9f\x87\xba"), "flag: European Union"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xab\xf0\x9f\x87\xae"), "flag: Finland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xab\xf0\x9f\x87\xaf"), "flag: Fiji"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xab\xf0\x9f\x87\xb0"), "flag: Falkland Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xab\xf0\x9f\x87\xb2"), "flag: Micronesia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xab\xf0\x9f\x87\xb4"), "flag: Faroe Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xab\xf0\x9f\x87\xb7"), "flag: France"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xa6"), "flag: Gabon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xa7"), "flag: United Kingdom"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xa9"), "flag: Grenada"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xaa"), "flag: Georgia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xab"), "flag: French Guiana"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xac"), "flag: Guernsey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xad"), "flag: Ghana"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xae"), "flag: Gibraltar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb1"), "flag: Greenland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb2"), "flag: Gambia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb3"), "flag: Guinea"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb5"), "flag: Guadeloupe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb6"), "flag: Equatorial Guinea"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb7"), "flag: Greece"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb8"),
        "flag: South Georgia & South Sandwich Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xb9"), "flag: Guatemala"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xba"), "flag: Guam"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xbc"), "flag: Guinea-Bissau"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xac\xf0\x9f\x87\xbe"), "flag: Guyana"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xad\xf0\x9f\x87\xb0"), "flag: Hong Kong SAR China"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xad\xf0\x9f\x87\xb2"), "flag: Heard & McDonald Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xad\xf0\x9f\x87\xb3"), "flag: Honduras"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xad\xf0\x9f\x87\xb7"), "flag: Croatia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xad\xf0\x9f\x87\xb9"), "flag: Haiti"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xad\xf0\x9f\x87\xba"), "flag: Hungary"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xa8"), "flag: Canary Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xa9"), "flag: Indonesia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xaa"), "flag: Ireland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb1"), "flag: Israel"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb2"), "flag: Isle of Man"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb3"), "flag: India"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb4"),
        "flag: British Indian Ocean Territory"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb6"), "flag: Iraq"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb7"), "flag: Iran"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb8"), "flag: Iceland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xae\xf0\x9f\x87\xb9"), "flag: Italy"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaf\xf0\x9f\x87\xaa"), "flag: Jersey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaf\xf0\x9f\x87\xb2"), "flag: Jamaica"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaf\xf0\x9f\x87\xb4"), "flag: Jordan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xaf\xf0\x9f\x87\xb5"), "flag: Japan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xaa"), "flag: Kenya"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xac"), "flag: Kyrgyzstan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xad"), "flag: Cambodia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xae"), "flag: Kiribati"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xb2"), "flag: Comoros"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xb3"), "flag: St. Kitts & Nevis"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xb5"), "flag: North Korea"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xb7"), "flag: South Korea"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xbc"), "flag: Kuwait"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xbe"), "flag: Cayman Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb0\xf0\x9f\x87\xbf"), "flag: Kazakhstan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xa6"), "flag: Laos"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xa7"), "flag: Lebanon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xa8"), "flag: St. Lucia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xae"), "flag: Liechtenstein"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xb0"), "flag: Sri Lanka"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xb7"), "flag: Liberia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xb8"), "flag: Lesotho"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xb9"), "flag: Lithuania"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xba"), "flag: Luxembourg"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xbb"), "flag: Latvia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb1\xf0\x9f\x87\xbe"), "flag: Libya"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xa6"), "flag: Morocco"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xa8"), "flag: Monaco"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xa9"), "flag: Moldova"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xaa"), "flag: Montenegro"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xab"), "flag: St. Martin"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xac"), "flag: Madagascar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xad"), "flag: Marshall Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb0"), "flag: North Macedonia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb1"), "flag: Mali"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb2"), "flag: Myanmar (Burma)"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb3"), "flag: Mongolia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb4"), "flag: Macao SAR China"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb5"), "flag: Northern Mariana Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb6"), "flag: Martinique"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb7"), "flag: Mauritania"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb8"), "flag: Montserrat"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xb9"), "flag: Malta"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xba"), "flag: Mauritius"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xbb"), "flag: Maldives"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xbc"), "flag: Malawi"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xbd"), "flag: Mexico"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xbe"), "flag: Malaysia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb2\xf0\x9f\x87\xbf"), "flag: Mozambique"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xa6"), "flag: Namibia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xa8"), "flag: New Caledonia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xaa"), "flag: Niger"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xab"), "flag: Norfolk Island"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xac"), "flag: Nigeria"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xae"), "flag: Nicaragua"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xb1"), "flag: Netherlands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xb4"), "flag: Norway"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xb5"), "flag: Nepal"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xb7"), "flag: Nauru"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xba"), "flag: Niue"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb3\xf0\x9f\x87\xbf"), "flag: New Zealand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb4\xf0\x9f\x87\xb2"), "flag: Oman"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xa6"), "flag: Panama"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xaa"), "flag: Peru"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xab"), "flag: French Polynesia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xac"), "flag: Papua New Guinea"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xad"), "flag: Philippines"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb0"), "flag: Pakistan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb1"), "flag: Poland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb2"), "flag: St. Pierre & Miquelon"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb3"), "flag: Pitcairn Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb7"), "flag: Puerto Rico"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb8"), "flag: Palestinian Territories"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xb9"), "flag: Portugal"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xbc"), "flag: Palau"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb5\xf0\x9f\x87\xbe"), "flag: Paraguay"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb6\xf0\x9f\x87\xa6"), "flag: Qatar"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb7\xf0\x9f\x87\xaa"), "flag: Réunion"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb7\xf0\x9f\x87\xb4"), "flag: Romania"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb7\xf0\x9f\x87\xb8"), "flag: Serbia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb7\xf0\x9f\x87\xba"), "flag: Russia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb7\xf0\x9f\x87\xbc"), "flag: Rwanda"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xa6"), "flag: Saudi Arabia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xa7"), "flag: Solomon Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xa8"), "flag: Seychelles"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xa9"), "flag: Sudan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xaa"), "flag: Sweden"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xac"), "flag: Singapore"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xad"), "flag: St. Helena"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xae"), "flag: Slovenia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xaf"), "flag: Svalbard & Jan Mayen"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb0"), "flag: Slovakia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb1"), "flag: Sierra Leone"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb2"), "flag: San Marino"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb3"), "flag: Senegal"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb4"), "flag: Somalia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb7"), "flag: Suriname"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb8"), "flag: South Sudan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xb9"), "flag: São Tomé & Príncipe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xbb"), "flag: El Salvador"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xbd"), "flag: Sint Maarten"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xbe"), "flag: Syria"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb8\xf0\x9f\x87\xbf"), "flag: Eswatini"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xa6"), "flag: Tristan da Cunha"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xa8"), "flag: Turks & Caicos Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xa9"), "flag: Chad"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xab"), "flag: French Southern Territories"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xac"), "flag: Togo"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xad"), "flag: Thailand"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xaf"), "flag: Tajikistan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb0"), "flag: Tokelau"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb1"), "flag: Timor-Leste"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb2"), "flag: Turkmenistan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb3"), "flag: Tunisia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb4"), "flag: Tonga"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb7"), "flag: Turkey"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xb9"), "flag: Trinidad & Tobago"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xbb"), "flag: Tuvalu"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xbc"), "flag: Taiwan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xb9\xf0\x9f\x87\xbf"), "flag: Tanzania"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xa6"), "flag: Ukraine"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xac"), "flag: Uganda"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xb2"), "flag: U.S. Outlying Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xb3"), "flag: United Nations"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xb8"), "flag: United States"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xbe"), "flag: Uruguay"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xba\xf0\x9f\x87\xbf"), "flag: Uzbekistan"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xa6"), "flag: Vatican City"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xa8"), "flag: St. Vincent & Grenadines"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xaa"), "flag: Venezuela"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xac"), "flag: British Virgin Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xae"), "flag: U.S. Virgin Islands"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xb3"), "flag: Vietnam"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbb\xf0\x9f\x87\xba"), "flag: Vanuatu"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbc\xf0\x9f\x87\xab"), "flag: Wallis & Futuna"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbc\xf0\x9f\x87\xb8"), "flag: Samoa"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbd\xf0\x9f\x87\xb0"), "flag: Kosovo"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbe\xf0\x9f\x87\xaa"), "flag: Yemen"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbe\xf0\x9f\x87\xb9"), "flag: Mayotte"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbf\xf0\x9f\x87\xa6"), "flag: South Africa"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbf\xf0\x9f\x87\xb2"), "flag: Zambia"},
  Emoji{QString::fromUtf8("\xf0\x9f\x87\xbf\xf0\x9f\x87\xbc"), "flag: Zimbabwe"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb4\xf3\xa0\x81\xa7\xf3\xa0\x81\xa2\xf3\xa0\x81\xa5\xf3\xa0"
                          "\x81\xae\xf3\xa0\x81\xa7\xf3\xa0\x81\xbf"),
        "flag: England"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb4\xf3\xa0\x81\xa7\xf3\xa0\x81\xa2\xf3\xa0\x81\xb3\xf3\xa0"
                          "\x81\xa3\xf3\xa0\x81\xb4\xf3\xa0\x81\xbf"),
        "flag: Scotland"},
  Emoji{QString::fromUtf8("\xf0\x9f\x8f\xb4\xf3\xa0\x81\xa7\xf3\xa0\x81\xa2\xf3\xa0\x81\xb7\xf3\xa0"
                          "\x81\xac\xf3\xa0\x81\xb3\xf3\xa0\x81\xbf"),
        "flag: Wales"},
};
